/* A Bison parser, made by GNU Bison 2.5.  */

/* Bison implementation for Yacc-like parsers in C
   
      Copyright (C) 1984, 1989-1990, 2000-2011 Free Software Foundation, Inc.
   
   This program is free software: you can redistribute it and/or modify
   it under the terms of the GNU General Public License as published by
   the Free Software Foundation, either version 3 of the License, or
   (at your option) any later version.
   
   This program is distributed in the hope that it will be useful,
   but WITHOUT ANY WARRANTY; without even the implied warranty of
   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
   GNU General Public License for more details.
   
   You should have received a copy of the GNU General Public License
   along with this program.  If not, see <http://www.gnu.org/licenses/>.  */

/* As a special exception, you may create a larger work that contains
   part or all of the Bison parser skeleton and distribute that work
   under terms of your choice, so long as that work isn't itself a
   parser generator using the skeleton or a modified version thereof
   as a parser skeleton.  Alternatively, if you modify or redistribute
   the parser skeleton itself, you may (at your option) remove this
   special exception, which will cause the skeleton and the resulting
   Bison output files to be licensed under the GNU General Public
   License without this special exception.
   
   This special exception was added by the Free Software Foundation in
   version 2.2 of Bison.  */

/* C LALR(1) parser skeleton written by Richard Stallman, by
   simplifying the original so-called "semantic" parser.  */

/* All symbols defined below should begin with yy or YY, to avoid
   infringing on user name space.  This should be done even for local
   variables, as they might otherwise be expanded by user macros.
   There are some unavoidable exceptions within include files to
   define necessary library symbols; they are noted "INFRINGES ON
   USER NAME SPACE" below.  */

/* Identify Bison output.  */
#define YYBISON 1

/* Bison version.  */
#define YYBISON_VERSION "2.5"

/* Skeleton name.  */
#define YYSKELETON_NAME "yacc.c"

/* Pure parsers.  */
#define YYPURE 0

/* Push parsers.  */
#define YYPUSH 0

/* Pull parsers.  */
#define YYPULL 1

/* Using locations.  */
#define YYLSP_NEEDED 0



/* Copy the first part of user declarations.  */

/* Line 268 of yacc.c  */
#line 31 "policy_parse.y"

#include <sys/types.h>
#include <assert.h>
#include <stdarg.h>
#include <stdint.h>
#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <sys/socket.h>
#include <netinet/in.h>
#include <arpa/inet.h>
#include <stdlib.h>

#include <sepol/policydb/expand.h>
#include <sepol/policydb/policydb.h>
#include <sepol/policydb/services.h>
#include <sepol/policydb/conditional.h>
#include <sepol/policydb/flask.h>
#include <sepol/policydb/hierarchy.h>
#include <sepol/policydb/polcaps.h>
#include "queue.h"
#include "checkpolicy.h"
#include "module_compiler.h"
#include "policy_define.h"

extern policydb_t *policydbp;
extern unsigned int pass;

extern char yytext[];
extern int yylex(void);
extern int yywarn(char *msg);
extern int yyerror(char *msg);

typedef int (* require_func_t)();



/* Line 268 of yacc.c  */
#line 109 "y.tab.c"

/* Enabling traces.  */
#ifndef YYDEBUG
# define YYDEBUG 0
#endif

/* Enabling verbose error messages.  */
#ifdef YYERROR_VERBOSE
# undef YYERROR_VERBOSE
# define YYERROR_VERBOSE 1
#else
# define YYERROR_VERBOSE 0
#endif

/* Enabling the token table.  */
#ifndef YYTOKEN_TABLE
# define YYTOKEN_TABLE 0
#endif


/* Tokens.  */
#ifndef YYTOKENTYPE
# define YYTOKENTYPE
   /* Put the tokens into the symbol table, so that GDB and other debuggers
      know about them.  */
   enum yytokentype {
     PATH = 258,
     FILENAME = 259,
     CLONE = 260,
     COMMON = 261,
     CLASS = 262,
     CONSTRAIN = 263,
     VALIDATETRANS = 264,
     INHERITS = 265,
     SID = 266,
     ROLE = 267,
     ROLEATTRIBUTE = 268,
     ATTRIBUTE_ROLE = 269,
     ROLES = 270,
     TYPEALIAS = 271,
     TYPEATTRIBUTE = 272,
     TYPEBOUNDS = 273,
     TYPE = 274,
     TYPES = 275,
     ALIAS = 276,
     ATTRIBUTE = 277,
     BOOL = 278,
     TUNABLE = 279,
     IF = 280,
     ELSE = 281,
     TYPE_TRANSITION = 282,
     TYPE_MEMBER = 283,
     TYPE_CHANGE = 284,
     ROLE_TRANSITION = 285,
     RANGE_TRANSITION = 286,
     SENSITIVITY = 287,
     DOMINANCE = 288,
     DOM = 289,
     DOMBY = 290,
     INCOMP = 291,
     CATEGORY = 292,
     LEVEL = 293,
     RANGE = 294,
     MLSCONSTRAIN = 295,
     MLSVALIDATETRANS = 296,
     USER = 297,
     NEVERALLOW = 298,
     ALLOW = 299,
     AUDITALLOW = 300,
     AUDITDENY = 301,
     DONTAUDIT = 302,
     SOURCE = 303,
     TARGET = 304,
     SAMEUSER = 305,
     FSCON = 306,
     PORTCON = 307,
     NETIFCON = 308,
     NODECON = 309,
     PIRQCON = 310,
     IOMEMCON = 311,
     IOPORTCON = 312,
     PCIDEVICECON = 313,
     FSUSEXATTR = 314,
     FSUSETASK = 315,
     FSUSETRANS = 316,
     GENFSCON = 317,
     U1 = 318,
     U2 = 319,
     U3 = 320,
     R1 = 321,
     R2 = 322,
     R3 = 323,
     T1 = 324,
     T2 = 325,
     T3 = 326,
     L1 = 327,
     L2 = 328,
     H1 = 329,
     H2 = 330,
     NOT = 331,
     AND = 332,
     OR = 333,
     XOR = 334,
     CTRUE = 335,
     CFALSE = 336,
     IDENTIFIER = 337,
     NUMBER = 338,
     EQUALS = 339,
     NOTEQUAL = 340,
     IPV4_ADDR = 341,
     IPV6_ADDR = 342,
     MODULE = 343,
     VERSION_IDENTIFIER = 344,
     REQUIRE = 345,
     OPTIONAL = 346,
     POLICYCAP = 347,
     PERMISSIVE = 348,
     FILESYSTEM = 349
   };
#endif
/* Tokens.  */
#define PATH 258
#define FILENAME 259
#define CLONE 260
#define COMMON 261
#define CLASS 262
#define CONSTRAIN 263
#define VALIDATETRANS 264
#define INHERITS 265
#define SID 266
#define ROLE 267
#define ROLEATTRIBUTE 268
#define ATTRIBUTE_ROLE 269
#define ROLES 270
#define TYPEALIAS 271
#define TYPEATTRIBUTE 272
#define TYPEBOUNDS 273
#define TYPE 274
#define TYPES 275
#define ALIAS 276
#define ATTRIBUTE 277
#define BOOL 278
#define TUNABLE 279
#define IF 280
#define ELSE 281
#define TYPE_TRANSITION 282
#define TYPE_MEMBER 283
#define TYPE_CHANGE 284
#define ROLE_TRANSITION 285
#define RANGE_TRANSITION 286
#define SENSITIVITY 287
#define DOMINANCE 288
#define DOM 289
#define DOMBY 290
#define INCOMP 291
#define CATEGORY 292
#define LEVEL 293
#define RANGE 294
#define MLSCONSTRAIN 295
#define MLSVALIDATETRANS 296
#define USER 297
#define NEVERALLOW 298
#define ALLOW 299
#define AUDITALLOW 300
#define AUDITDENY 301
#define DONTAUDIT 302
#define SOURCE 303
#define TARGET 304
#define SAMEUSER 305
#define FSCON 306
#define PORTCON 307
#define NETIFCON 308
#define NODECON 309
#define PIRQCON 310
#define IOMEMCON 311
#define IOPORTCON 312
#define PCIDEVICECON 313
#define FSUSEXATTR 314
#define FSUSETASK 315
#define FSUSETRANS 316
#define GENFSCON 317
#define U1 318
#define U2 319
#define U3 320
#define R1 321
#define R2 322
#define R3 323
#define T1 324
#define T2 325
#define T3 326
#define L1 327
#define L2 328
#define H1 329
#define H2 330
#define NOT 331
#define AND 332
#define OR 333
#define XOR 334
#define CTRUE 335
#define CFALSE 336
#define IDENTIFIER 337
#define NUMBER 338
#define EQUALS 339
#define NOTEQUAL 340
#define IPV4_ADDR 341
#define IPV6_ADDR 342
#define MODULE 343
#define VERSION_IDENTIFIER 344
#define REQUIRE 345
#define OPTIONAL 346
#define POLICYCAP 347
#define PERMISSIVE 348
#define FILESYSTEM 349




#if ! defined YYSTYPE && ! defined YYSTYPE_IS_DECLARED
typedef union YYSTYPE
{

/* Line 293 of yacc.c  */
#line 68 "policy_parse.y"

	unsigned int val;
	uintptr_t valptr;
	void *ptr;
        require_func_t require_func;



/* Line 293 of yacc.c  */
#line 342 "y.tab.c"
} YYSTYPE;
# define YYSTYPE_IS_TRIVIAL 1
# define yystype YYSTYPE /* obsolescent; will be withdrawn */
# define YYSTYPE_IS_DECLARED 1
#endif


/* Copy the second part of user declarations.  */


/* Line 343 of yacc.c  */
#line 354 "y.tab.c"

#ifdef short
# undef short
#endif

#ifdef YYTYPE_UINT8
typedef YYTYPE_UINT8 yytype_uint8;
#else
typedef unsigned char yytype_uint8;
#endif

#ifdef YYTYPE_INT8
typedef YYTYPE_INT8 yytype_int8;
#elif (defined __STDC__ || defined __C99__FUNC__ \
     || defined __cplusplus || defined _MSC_VER)
typedef signed char yytype_int8;
#else
typedef short int yytype_int8;
#endif

#ifdef YYTYPE_UINT16
typedef YYTYPE_UINT16 yytype_uint16;
#else
typedef unsigned short int yytype_uint16;
#endif

#ifdef YYTYPE_INT16
typedef YYTYPE_INT16 yytype_int16;
#else
typedef short int yytype_int16;
#endif

#ifndef YYSIZE_T
# ifdef __SIZE_TYPE__
#  define YYSIZE_T __SIZE_TYPE__
# elif defined size_t
#  define YYSIZE_T size_t
# elif ! defined YYSIZE_T && (defined __STDC__ || defined __C99__FUNC__ \
     || defined __cplusplus || defined _MSC_VER)
#  include <stddef.h> /* INFRINGES ON USER NAME SPACE */
#  define YYSIZE_T size_t
# else
#  define YYSIZE_T unsigned int
# endif
#endif

#define YYSIZE_MAXIMUM ((YYSIZE_T) -1)

#ifndef YY_
# if defined YYENABLE_NLS && YYENABLE_NLS
#  if ENABLE_NLS
#   include <libintl.h> /* INFRINGES ON USER NAME SPACE */
#   define YY_(msgid) dgettext ("bison-runtime", msgid)
#  endif
# endif
# ifndef YY_
#  define YY_(msgid) msgid
# endif
#endif

/* Suppress unused-variable warnings by "using" E.  */
#if ! defined lint || defined __GNUC__
# define YYUSE(e) ((void) (e))
#else
# define YYUSE(e) /* empty */
#endif

/* Identity function, used to suppress warnings about constant conditions.  */
#ifndef lint
# define YYID(n) (n)
#else
#if (defined __STDC__ || defined __C99__FUNC__ \
     || defined __cplusplus || defined _MSC_VER)
static int
YYID (int yyi)
#else
static int
YYID (yyi)
    int yyi;
#endif
{
  return yyi;
}
#endif

#if ! defined yyoverflow || YYERROR_VERBOSE

/* The parser invokes alloca or malloc; define the necessary symbols.  */

# ifdef YYSTACK_USE_ALLOCA
#  if YYSTACK_USE_ALLOCA
#   ifdef __GNUC__
#    define YYSTACK_ALLOC __builtin_alloca
#   elif defined __BUILTIN_VA_ARG_INCR
#    include <alloca.h> /* INFRINGES ON USER NAME SPACE */
#   elif defined _AIX
#    define YYSTACK_ALLOC __alloca
#   elif defined _MSC_VER
#    include <malloc.h> /* INFRINGES ON USER NAME SPACE */
#    define alloca _alloca
#   else
#    define YYSTACK_ALLOC alloca
#    if ! defined _ALLOCA_H && ! defined EXIT_SUCCESS && (defined __STDC__ || defined __C99__FUNC__ \
     || defined __cplusplus || defined _MSC_VER)
#     include <stdlib.h> /* INFRINGES ON USER NAME SPACE */
#     ifndef EXIT_SUCCESS
#      define EXIT_SUCCESS 0
#     endif
#    endif
#   endif
#  endif
# endif

# ifdef YYSTACK_ALLOC
   /* Pacify GCC's `empty if-body' warning.  */
#  define YYSTACK_FREE(Ptr) do { /* empty */; } while (YYID (0))
#  ifndef YYSTACK_ALLOC_MAXIMUM
    /* The OS might guarantee only one guard page at the bottom of the stack,
       and a page size can be as small as 4096 bytes.  So we cannot safely
       invoke alloca (N) if N exceeds 4096.  Use a slightly smaller number
       to allow for a few compiler-allocated temporary stack slots.  */
#   define YYSTACK_ALLOC_MAXIMUM 4032 /* reasonable circa 2006 */
#  endif
# else
#  define YYSTACK_ALLOC YYMALLOC
#  define YYSTACK_FREE YYFREE
#  ifndef YYSTACK_ALLOC_MAXIMUM
#   define YYSTACK_ALLOC_MAXIMUM YYSIZE_MAXIMUM
#  endif
#  if (defined __cplusplus && ! defined EXIT_SUCCESS \
       && ! ((defined YYMALLOC || defined malloc) \
	     && (defined YYFREE || defined free)))
#   include <stdlib.h> /* INFRINGES ON USER NAME SPACE */
#   ifndef EXIT_SUCCESS
#    define EXIT_SUCCESS 0
#   endif
#  endif
#  ifndef YYMALLOC
#   define YYMALLOC malloc
#   if ! defined malloc && ! defined EXIT_SUCCESS && (defined __STDC__ || defined __C99__FUNC__ \
     || defined __cplusplus || defined _MSC_VER)
void *malloc (YYSIZE_T); /* INFRINGES ON USER NAME SPACE */
#   endif
#  endif
#  ifndef YYFREE
#   define YYFREE free
#   if ! defined free && ! defined EXIT_SUCCESS && (defined __STDC__ || defined __C99__FUNC__ \
     || defined __cplusplus || defined _MSC_VER)
void free (void *); /* INFRINGES ON USER NAME SPACE */
#   endif
#  endif
# endif
#endif /* ! defined yyoverflow || YYERROR_VERBOSE */


#if (! defined yyoverflow \
     && (! defined __cplusplus \
	 || (defined YYSTYPE_IS_TRIVIAL && YYSTYPE_IS_TRIVIAL)))

/* A type that is properly aligned for any stack member.  */
union yyalloc
{
  yytype_int16 yyss_alloc;
  YYSTYPE yyvs_alloc;
};

/* The size of the maximum gap between one aligned stack and the next.  */
# define YYSTACK_GAP_MAXIMUM (sizeof (union yyalloc) - 1)

/* The size of an array large to enough to hold all stacks, each with
   N elements.  */
# define YYSTACK_BYTES(N) \
     ((N) * (sizeof (yytype_int16) + sizeof (YYSTYPE)) \
      + YYSTACK_GAP_MAXIMUM)

# define YYCOPY_NEEDED 1

/* Relocate STACK from its old location to the new one.  The
   local variables YYSIZE and YYSTACKSIZE give the old and new number of
   elements in the stack, and YYPTR gives the new location of the
   stack.  Advance YYPTR to a properly aligned location for the next
   stack.  */
# define YYSTACK_RELOCATE(Stack_alloc, Stack)				\
    do									\
      {									\
	YYSIZE_T yynewbytes;						\
	YYCOPY (&yyptr->Stack_alloc, Stack, yysize);			\
	Stack = &yyptr->Stack_alloc;					\
	yynewbytes = yystacksize * sizeof (*Stack) + YYSTACK_GAP_MAXIMUM; \
	yyptr += yynewbytes / sizeof (*yyptr);				\
      }									\
    while (YYID (0))

#endif

#if defined YYCOPY_NEEDED && YYCOPY_NEEDED
/* Copy COUNT objects from FROM to TO.  The source and destination do
   not overlap.  */
# ifndef YYCOPY
#  if defined __GNUC__ && 1 < __GNUC__
#   define YYCOPY(To, From, Count) \
      __builtin_memcpy (To, From, (Count) * sizeof (*(From)))
#  else
#   define YYCOPY(To, From, Count)		\
      do					\
	{					\
	  YYSIZE_T yyi;				\
	  for (yyi = 0; yyi < (Count); yyi++)	\
	    (To)[yyi] = (From)[yyi];		\
	}					\
      while (YYID (0))
#  endif
# endif
#endif /* !YYCOPY_NEEDED */

/* YYFINAL -- State number of the termination state.  */
#define YYFINAL  9
/* YYLAST -- Last index in YYTABLE.  */
#define YYLAST   929

/* YYNTOKENS -- Number of terminals.  */
#define YYNTOKENS  105
/* YYNNTS -- Number of nonterminals.  */
#define YYNNTS  173
/* YYNRULES -- Number of rules.  */
#define YYNRULES  347
/* YYNRULES -- Number of states.  */
#define YYNSTATES  689

/* YYTRANSLATE(YYLEX) -- Bison symbol number corresponding to YYLEX.  */
#define YYUNDEFTOK  2
#define YYMAXUTOK   349

#define YYTRANSLATE(YYX)						\
  ((unsigned int) (YYX) <= YYMAXUTOK ? yytranslate[YYX] : YYUNDEFTOK)

/* YYTRANSLATE[YYLEX] -- Bison symbol number corresponding to YYLEX.  */
static const yytype_uint8 yytranslate[] =
{
       0,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
     100,   101,   104,     2,    99,   102,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,    98,    97,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,    95,     2,    96,   103,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     1,     2,     3,     4,
       5,     6,     7,     8,     9,    10,    11,    12,    13,    14,
      15,    16,    17,    18,    19,    20,    21,    22,    23,    24,
      25,    26,    27,    28,    29,    30,    31,    32,    33,    34,
      35,    36,    37,    38,    39,    40,    41,    42,    43,    44,
      45,    46,    47,    48,    49,    50,    51,    52,    53,    54,
      55,    56,    57,    58,    59,    60,    61,    62,    63,    64,
      65,    66,    67,    68,    69,    70,    71,    72,    73,    74,
      75,    76,    77,    78,    79,    80,    81,    82,    83,    84,
      85,    86,    87,    88,    89,    90,    91,    92,    93,    94
};

#if YYDEBUG
/* YYPRHS[YYN] -- Index of the first RHS symbol of rule number YYN in
   YYRHS.  */
static const yytype_uint16 yyprhs[] =
{
       0,     0,     3,     5,     7,     8,     9,    10,    27,    29,
      32,    35,    37,    40,    43,    46,    48,    49,    51,    54,
      60,    62,    65,    71,    76,    84,    86,    87,    93,    95,
      98,   103,   107,   110,   113,   118,   120,   121,   123,   126,
     131,   135,   137,   140,   146,   150,   152,   155,   157,   159,
     165,   170,   172,   175,   177,   179,   181,   183,   185,   187,
     189,   191,   193,   195,   197,   199,   201,   203,   205,   207,
     209,   211,   213,   215,   217,   219,   221,   223,   227,   233,
     238,   243,   248,   253,   256,   257,   262,   267,   269,   271,
     278,   283,   284,   288,   291,   295,   299,   303,   307,   311,
     313,   315,   318,   319,   321,   323,   325,   334,   342,   350,
     358,   360,   362,   364,   366,   374,   382,   390,   398,   407,
     415,   423,   431,   437,   445,   447,   449,   451,   453,   455,
     463,   471,   479,   487,   495,   499,   505,   510,   515,   521,
     529,   534,   536,   539,   543,   549,   554,   556,   557,   559,
     562,   564,   566,   572,   577,   581,   584,   588,   592,   594,
     598,   602,   606,   607,   612,   613,   618,   619,   624,   625,
     630,   631,   636,   637,   642,   643,   648,   649,   654,   655,
     660,   662,   663,   668,   669,   674,   677,   678,   683,   684,
     689,   693,   697,   701,   705,   709,   713,   715,   717,   719,
     721,   723,   725,   727,   730,   737,   742,   743,   745,   748,
     752,   754,   755,   757,   760,   762,   764,   766,   768,   772,
     776,   782,   786,   792,   796,   798,   799,   801,   804,   810,
     814,   816,   817,   819,   822,   827,   834,   836,   837,   839,
     842,   847,   849,   850,   852,   855,   860,   865,   867,   868,
     870,   873,   878,   883,   888,   890,   891,   893,   896,   903,
     904,   912,   917,   919,   926,   929,   930,   934,   936,   940,
     942,   944,   948,   950,   952,   954,   956,   958,   961,   964,
     965,   970,   972,   974,   976,   980,   982,   985,   990,   992,
     995,   997,   999,  1002,  1006,  1008,  1011,  1013,  1014,  1018,
    1020,  1022,  1024,  1026,  1028,  1030,  1032,  1034,  1038,  1042,
    1045,  1050,  1052,  1054,  1056,  1059,  1062,  1064,  1066,  1068,
    1070,  1072,  1074,  1076,  1081,  1084,  1086,  1089,  1093,  1097,
    1099,  1101,  1103,  1105,  1107,  1109,  1111,  1113,  1115,  1117,
    1121,  1122,  1129,  1134,  1135,  1137,  1139,  1142
};

/* YYRHS -- A `-1'-separated list of the rules' RHS.  */
static const yytype_int16 yyrhs[] =
{
     106,     0,    -1,   107,    -1,   260,    -1,    -1,    -1,    -1,
     108,   111,   113,   115,   109,   121,   136,   200,   178,   110,
     203,   212,   225,   228,   215,   205,    -1,   112,    -1,   111,
     112,    -1,     7,   252,    -1,   114,    -1,   113,   114,    -1,
      11,   252,    -1,   116,   119,    -1,   117,    -1,    -1,   118,
      -1,   117,   118,    -1,     6,   252,    95,   247,    96,    -1,
     120,    -1,   119,   120,    -1,     7,   252,    95,   247,    96,
      -1,     7,   252,    10,   252,    -1,     7,   252,    10,   252,
      95,   247,    96,    -1,   122,    -1,    -1,   123,   126,   127,
     130,   132,    -1,   124,    -1,   123,   124,    -1,    32,   252,
     125,    97,    -1,    32,   252,    97,    -1,    21,   240,    -1,
      33,   252,    -1,    33,    95,   247,    96,    -1,   128,    -1,
      -1,   129,    -1,   128,   129,    -1,    37,   252,   125,    97,
      -1,    37,   252,    97,    -1,   131,    -1,   130,   131,    -1,
      38,   252,    98,   237,    97,    -1,    38,   252,    97,    -1,
     133,    -1,   132,   133,    -1,   134,    -1,   135,    -1,    40,
     240,   240,   183,    97,    -1,    41,   240,   183,    97,    -1,
     137,    -1,   136,   137,    -1,   139,    -1,   138,    -1,   149,
      -1,   272,    -1,   258,    -1,    97,    -1,   169,    -1,   170,
      -1,   172,    -1,   173,    -1,   174,    -1,   177,    -1,   171,
      -1,   140,    -1,   141,    -1,   142,    -1,   143,    -1,   144,
      -1,   146,    -1,   147,    -1,   161,    -1,   162,    -1,   163,
      -1,   259,    -1,    22,   252,    97,    -1,    19,   252,   125,
     145,    97,    -1,    19,   252,   145,    97,    -1,    16,   252,
     125,    97,    -1,    17,   252,   237,    97,    -1,    18,   252,
     237,    97,    -1,    99,   237,    -1,    -1,    23,   252,   148,
      97,    -1,    24,   252,   148,    97,    -1,    80,    -1,    81,
      -1,    25,   151,    95,   153,    96,   150,    -1,    26,    95,
     153,    96,    -1,    -1,   100,   151,   101,    -1,    76,   151,
      -1,   151,    77,   151,    -1,   151,    78,   151,    -1,   151,
      79,   151,    -1,   151,    84,   151,    -1,   151,    85,   151,
      -1,   152,    -1,   252,    -1,   153,   154,    -1,    -1,   155,
      -1,   156,    -1,   266,    -1,    27,   240,   240,    98,   240,
     252,   255,    97,    -1,    27,   240,   240,    98,   240,   252,
      97,    -1,    28,   240,   240,    98,   240,   252,    97,    -1,
      29,   240,   240,    98,   240,   252,    97,    -1,   157,    -1,
     158,    -1,   159,    -1,   160,    -1,    44,   240,   240,    98,
     240,   240,    97,    -1,    45,   240,   240,    98,   240,   240,
      97,    -1,    46,   240,   240,    98,   240,   240,    97,    -1,
      47,   240,   240,    98,   240,   240,    97,    -1,    27,   240,
     240,    98,   240,   252,   255,    97,    -1,    27,   240,   240,
      98,   240,   252,    97,    -1,    28,   240,   240,    98,   240,
     252,    97,    -1,    29,   240,   240,    98,   240,   252,    97,
      -1,    31,   240,   240,   235,    97,    -1,    31,   240,   240,
      98,   240,   235,    97,    -1,   164,    -1,   165,    -1,   166,
      -1,   167,    -1,   168,    -1,    44,   240,   240,    98,   240,
     240,    97,    -1,    45,   240,   240,    98,   240,   240,    97,
      -1,    46,   240,   240,    98,   240,   240,    97,    -1,    47,
     240,   240,    98,   240,   240,    97,    -1,    43,   240,   240,
      98,   240,   240,    97,    -1,    14,   252,    97,    -1,    12,
     252,    20,   240,    97,    -1,    12,   252,   145,    97,    -1,
      33,    95,   175,    96,    -1,    30,   240,   240,   252,    97,
      -1,    30,   240,   240,    98,   240,   252,    97,    -1,    44,
     240,   240,    97,    -1,   176,    -1,   175,   176,    -1,    12,
     246,    97,    -1,    12,   246,    95,   175,    96,    -1,    13,
     252,   237,    97,    -1,   179,    -1,    -1,   180,    -1,   179,
     180,    -1,   181,    -1,   182,    -1,     8,   240,   240,   183,
      97,    -1,     9,   240,   183,    97,    -1,   100,   183,   101,
      -1,    76,   183,    -1,   183,    77,   183,    -1,   183,    78,
     183,    -1,   184,    -1,    63,   198,    64,    -1,    66,   199,
      67,    -1,    69,   198,    70,    -1,    -1,    63,   198,   185,
     244,    -1,    -1,    64,   198,   186,   244,    -1,    -1,    65,
     198,   187,   244,    -1,    -1,    66,   198,   188,   244,    -1,
      -1,    67,   198,   189,   244,    -1,    -1,    68,   198,   190,
     244,    -1,    -1,    69,   198,   191,   244,    -1,    -1,    70,
     198,   192,   244,    -1,    -1,    71,   198,   193,   244,    -1,
      50,    -1,    -1,    48,    12,   194,   244,    -1,    -1,    49,
      12,   195,   244,    -1,    12,   199,    -1,    -1,    48,    19,
     196,   244,    -1,    -1,    49,    19,   197,   244,    -1,    72,
     199,    73,    -1,    72,   199,    75,    -1,    74,   199,    73,
      -1,    74,   199,    75,    -1,    72,   199,    74,    -1,    73,
     199,    75,    -1,    84,    -1,    85,    -1,   198,    -1,    34,
      -1,    35,    -1,    36,    -1,   201,    -1,   200,   201,    -1,
      42,   252,    15,   240,   202,    97,    -1,    38,   236,    39,
     235,    -1,    -1,   204,    -1,   203,   204,    -1,    11,   252,
     233,    -1,   206,    -1,    -1,   207,    -1,   206,   207,    -1,
     208,    -1,   209,    -1,   210,    -1,   211,    -1,    55,   256,
     233,    -1,    56,   256,   233,    -1,    56,   256,   102,   256,
     233,    -1,    57,   256,   233,    -1,    57,   256,   102,   256,
     233,    -1,    58,   256,   233,    -1,   213,    -1,    -1,   214,
      -1,   213,   214,    -1,    51,   256,   256,   233,   233,    -1,
     216,   219,   222,    -1,   217,    -1,    -1,   218,    -1,   217,
     218,    -1,    52,   252,   256,   233,    -1,    52,   252,   256,
     102,   256,   233,    -1,   220,    -1,    -1,   221,    -1,   220,
     221,    -1,    53,   252,   233,   233,    -1,   223,    -1,    -1,
     224,    -1,   223,   224,    -1,    54,   232,   232,   233,    -1,
      54,   257,   257,   233,    -1,   226,    -1,    -1,   227,    -1,
     226,   227,    -1,    59,   253,   233,    97,    -1,    60,   252,
     233,    97,    -1,    61,   252,   233,    97,    -1,   229,    -1,
      -1,   230,    -1,   229,   230,    -1,    62,   253,   254,   102,
     252,   233,    -1,    -1,    62,   253,   254,   102,   102,   231,
     233,    -1,    62,   253,   254,   233,    -1,    86,    -1,   252,
      98,   252,    98,   252,   234,    -1,    98,   235,    -1,    -1,
     236,   102,   236,    -1,   236,    -1,   252,    98,   237,    -1,
     252,    -1,   252,    -1,   237,    99,   252,    -1,   103,    -1,
     104,    -1,   252,    -1,   248,    -1,   239,    -1,   238,   252,
      -1,   238,   248,    -1,    -1,   252,   102,   241,   252,    -1,
     238,    -1,   239,    -1,   246,    -1,    95,   245,    96,    -1,
     243,    -1,   242,   246,    -1,   242,    95,   245,    96,    -1,
     246,    -1,   245,   246,    -1,    82,    -1,   252,    -1,   247,
     252,    -1,    95,   249,    96,    -1,   250,    -1,   249,   250,
      -1,   252,    -1,    -1,   102,   251,   252,    -1,   248,    -1,
      82,    -1,    94,    -1,    82,    -1,     3,    -1,     4,    -1,
      83,    -1,    87,    -1,    92,   252,    97,    -1,    93,   252,
      97,    -1,   261,   263,    -1,    88,   252,   262,    97,    -1,
      89,    -1,   256,    -1,   232,    -1,   264,   277,    -1,   264,
     265,    -1,   265,    -1,   138,    -1,   139,    -1,   149,    -1,
     266,    -1,   272,    -1,    97,    -1,    90,    95,   267,    96,
      -1,   267,   268,    -1,   268,    -1,   269,    97,    -1,   270,
     271,    97,    -1,     7,   252,   240,    -1,    12,    -1,    19,
      -1,    22,    -1,    14,    -1,    42,    -1,    23,    -1,    24,
      -1,    32,    -1,    37,    -1,   252,    -1,   271,    99,   252,
      -1,    -1,   275,    95,   263,    96,   273,   274,    -1,   276,
      95,   263,    96,    -1,    -1,    91,    -1,    26,    -1,   201,
     277,    -1,    -1
};

/* YYRLINE[YYN] -- source line where rule number YYN was defined.  */
static const yytype_uint16 yyrline[] =
{
       0,   153,   153,   154,   156,   158,   161,   156,   165,   166,
     168,   171,   172,   174,   177,   179,   180,   182,   183,   185,
     188,   189,   191,   193,   195,   198,   199,   201,   203,   204,
     206,   208,   211,   213,   215,   218,   219,   221,   222,   224,
     226,   229,   230,   232,   234,   237,   238,   240,   241,   243,
     246,   249,   250,   252,   253,   254,   255,   256,   257,   259,
     260,   261,   262,   263,   264,   265,   267,   268,   269,   270,
     271,   272,   273,   274,   275,   276,   277,   279,   282,   284,
     287,   290,   293,   296,   297,   299,   302,   305,   307,   310,
     313,   316,   317,   319,   322,   325,   328,   331,   334,   337,
     340,   344,   347,   349,   351,   353,   356,   359,   362,   365,
     369,   371,   373,   375,   378,   382,   386,   390,   395,   397,
     399,   401,   404,   406,   409,   410,   411,   412,   413,   415,
     418,   421,   424,   427,   430,   433,   436,   439,   441,   443,
     446,   449,   451,   454,   456,   459,   462,   463,   465,   466,
     468,   469,   471,   474,   477,   479,   482,   485,   488,   491,
     494,   497,   500,   500,   503,   503,   506,   506,   509,   509,
     512,   512,   515,   515,   518,   518,   521,   521,   524,   524,
     527,   530,   530,   533,   533,   536,   539,   539,   542,   542,
     545,   548,   551,   554,   557,   560,   564,   566,   569,   571,
     573,   575,   578,   579,   581,   584,   585,   587,   588,   590,
     593,   593,   595,   596,   598,   599,   600,   601,   603,   606,
     608,   611,   613,   616,   619,   620,   622,   623,   625,   628,
     630,   631,   633,   634,   636,   638,   641,   642,   644,   645,
     647,   650,   651,   653,   654,   656,   658,   661,   662,   664,
     665,   667,   669,   671,   674,   675,   677,   678,   680,   682,
     682,   684,   687,   690,   692,   693,   695,   697,   700,   702,
     705,   706,   708,   710,   712,   714,   716,   719,   722,   725,
     725,   728,   731,   734,   735,   736,   737,   738,   740,   741,
     743,   746,   747,   749,   751,   751,   753,   753,   753,   753,
     755,   758,   760,   763,   766,   769,   772,   775,   778,   783,
     788,   791,   793,   795,   797,   799,   800,   802,   803,   804,
     805,   806,   807,   809,   811,   812,   814,   815,   817,   820,
     821,   822,   823,   824,   825,   826,   827,   828,   830,   832,
     836,   835,   840,   842,   844,   847,   850,   851
};
#endif

#if YYDEBUG || YYERROR_VERBOSE || YYTOKEN_TABLE
/* YYTNAME[SYMBOL-NUM] -- String name of the symbol SYMBOL-NUM.
   First, the terminals, then, starting at YYNTOKENS, nonterminals.  */
static const char *const yytname[] =
{
  "$end", "error", "$undefined", "PATH", "FILENAME", "CLONE", "COMMON",
  "CLASS", "CONSTRAIN", "VALIDATETRANS", "INHERITS", "SID", "ROLE",
  "ROLEATTRIBUTE", "ATTRIBUTE_ROLE", "ROLES", "TYPEALIAS", "TYPEATTRIBUTE",
  "TYPEBOUNDS", "TYPE", "TYPES", "ALIAS", "ATTRIBUTE", "BOOL", "TUNABLE",
  "IF", "ELSE", "TYPE_TRANSITION", "TYPE_MEMBER", "TYPE_CHANGE",
  "ROLE_TRANSITION", "RANGE_TRANSITION", "SENSITIVITY", "DOMINANCE", "DOM",
  "DOMBY", "INCOMP", "CATEGORY", "LEVEL", "RANGE", "MLSCONSTRAIN",
  "MLSVALIDATETRANS", "USER", "NEVERALLOW", "ALLOW", "AUDITALLOW",
  "AUDITDENY", "DONTAUDIT", "SOURCE", "TARGET", "SAMEUSER", "FSCON",
  "PORTCON", "NETIFCON", "NODECON", "PIRQCON", "IOMEMCON", "IOPORTCON",
  "PCIDEVICECON", "FSUSEXATTR", "FSUSETASK", "FSUSETRANS", "GENFSCON",
  "U1", "U2", "U3", "R1", "R2", "R3", "T1", "T2", "T3", "L1", "L2", "H1",
  "H2", "NOT", "AND", "OR", "XOR", "CTRUE", "CFALSE", "IDENTIFIER",
  "NUMBER", "EQUALS", "NOTEQUAL", "IPV4_ADDR", "IPV6_ADDR", "MODULE",
  "VERSION_IDENTIFIER", "REQUIRE", "OPTIONAL", "POLICYCAP", "PERMISSIVE",
  "FILESYSTEM", "'{'", "'}'", "';'", "':'", "','", "'('", "')'", "'-'",
  "'~'", "'*'", "$accept", "policy", "base_policy", "$@1", "$@2", "$@3",
  "classes", "class_def", "initial_sids", "initial_sid_def",
  "access_vectors", "opt_common_perms", "common_perms", "common_perms_def",
  "av_perms", "av_perms_def", "opt_mls", "mls", "sensitivities",
  "sensitivity_def", "alias_def", "dominance", "opt_categories",
  "categories", "category_def", "levels", "level_def", "mlspolicy",
  "mlspolicy_decl", "mlsconstraint_def", "mlsvalidatetrans_def", "te_rbac",
  "te_rbac_decl", "rbac_decl", "te_decl", "attribute_def", "type_def",
  "typealias_def", "typeattribute_def", "typebounds_def", "opt_attr_list",
  "bool_def", "tunable_def", "bool_val", "cond_stmt_def", "cond_else",
  "cond_expr", "cond_expr_prim", "cond_pol_list", "cond_rule_def",
  "cond_transition_def", "cond_te_avtab_def", "cond_allow_def",
  "cond_auditallow_def", "cond_auditdeny_def", "cond_dontaudit_def",
  "transition_def", "range_trans_def", "te_avtab_def", "allow_def",
  "auditallow_def", "auditdeny_def", "dontaudit_def", "neverallow_def",
  "attribute_role_def", "role_type_def", "role_attr_def", "role_dominance",
  "role_trans_def", "role_allow_def", "roles", "role_def",
  "roleattribute_def", "opt_constraints", "constraints", "constraint_decl",
  "constraint_def", "validatetrans_def", "cexpr", "cexpr_prim", "$@4",
  "$@5", "$@6", "$@7", "$@8", "$@9", "$@10", "$@11", "$@12", "$@13",
  "$@14", "$@15", "$@16", "op", "role_mls_op", "users", "user_def",
  "opt_mls_user", "initial_sid_contexts", "initial_sid_context_def",
  "opt_dev_contexts", "dev_contexts", "dev_context_def",
  "pirq_context_def", "iomem_context_def", "ioport_context_def",
  "pci_context_def", "opt_fs_contexts", "fs_contexts", "fs_context_def",
  "net_contexts", "opt_port_contexts", "port_contexts", "port_context_def",
  "opt_netif_contexts", "netif_contexts", "netif_context_def",
  "opt_node_contexts", "node_contexts", "node_context_def", "opt_fs_uses",
  "fs_uses", "fs_use_def", "opt_genfs_contexts", "genfs_contexts",
  "genfs_context_def", "$@17", "ipv4_addr_def", "security_context_def",
  "opt_mls_range_def", "mls_range_def", "mls_level_def", "id_comma_list",
  "tilde", "asterisk", "names", "$@18", "tilde_push", "asterisk_push",
  "names_push", "identifier_list_push", "identifier_push",
  "identifier_list", "nested_id_set", "nested_id_list",
  "nested_id_element", "$@19", "identifier", "filesystem", "path",
  "filename", "number", "ipv6_addr", "policycap_def", "permissive_def",
  "module_policy", "module_def", "version_identifier", "avrules_block",
  "avrule_decls", "avrule_decl", "require_block", "require_list",
  "require_decl", "require_class", "require_decl_def", "require_id_list",
  "optional_block", "$@20", "optional_else", "optional_decl", "else_decl",
  "avrule_user_defs", 0
};
#endif

# ifdef YYPRINT
/* YYTOKNUM[YYLEX-NUM] -- Internal token number corresponding to
   token YYLEX-NUM.  */
static const yytype_uint16 yytoknum[] =
{
       0,   256,   257,   258,   259,   260,   261,   262,   263,   264,
     265,   266,   267,   268,   269,   270,   271,   272,   273,   274,
     275,   276,   277,   278,   279,   280,   281,   282,   283,   284,
     285,   286,   287,   288,   289,   290,   291,   292,   293,   294,
     295,   296,   297,   298,   299,   300,   301,   302,   303,   304,
     305,   306,   307,   308,   309,   310,   311,   312,   313,   314,
     315,   316,   317,   318,   319,   320,   321,   322,   323,   324,
     325,   326,   327,   328,   329,   330,   331,   332,   333,   334,
     335,   336,   337,   338,   339,   340,   341,   342,   343,   344,
     345,   346,   347,   348,   349,   123,   125,    59,    58,    44,
      40,    41,    45,   126,    42
};
# endif

/* YYR1[YYN] -- Symbol number of symbol that rule YYN derives.  */
static const yytype_uint16 yyr1[] =
{
       0,   105,   106,   106,   108,   109,   110,   107,   111,   111,
     112,   113,   113,   114,   115,   116,   116,   117,   117,   118,
     119,   119,   120,   120,   120,   121,   121,   122,   123,   123,
     124,   124,   125,   126,   126,   127,   127,   128,   128,   129,
     129,   130,   130,   131,   131,   132,   132,   133,   133,   134,
     135,   136,   136,   137,   137,   137,   137,   137,   137,   138,
     138,   138,   138,   138,   138,   138,   139,   139,   139,   139,
     139,   139,   139,   139,   139,   139,   139,   140,   141,   141,
     142,   143,   144,   145,   145,   146,   147,   148,   148,   149,
     150,   150,   151,   151,   151,   151,   151,   151,   151,   151,
     152,   153,   153,   154,   154,   154,   155,   155,   155,   155,
     156,   156,   156,   156,   157,   158,   159,   160,   161,   161,
     161,   161,   162,   162,   163,   163,   163,   163,   163,   164,
     165,   166,   167,   168,   169,   170,   171,   172,   173,   173,
     174,   175,   175,   176,   176,   177,   178,   178,   179,   179,
     180,   180,   181,   182,   183,   183,   183,   183,   183,   184,
     184,   184,   185,   184,   186,   184,   187,   184,   188,   184,
     189,   184,   190,   184,   191,   184,   192,   184,   193,   184,
     184,   194,   184,   195,   184,   184,   196,   184,   197,   184,
     184,   184,   184,   184,   184,   184,   198,   198,   199,   199,
     199,   199,   200,   200,   201,   202,   202,   203,   203,   204,
     205,   205,   206,   206,   207,   207,   207,   207,   208,   209,
     209,   210,   210,   211,   212,   212,   213,   213,   214,   215,
     216,   216,   217,   217,   218,   218,   219,   219,   220,   220,
     221,   222,   222,   223,   223,   224,   224,   225,   225,   226,
     226,   227,   227,   227,   228,   228,   229,   229,   230,   231,
     230,   230,   232,   233,   234,   234,   235,   235,   236,   236,
     237,   237,   238,   239,   240,   240,   240,   240,   240,   241,
     240,   242,   243,   244,   244,   244,   244,   244,   245,   245,
     246,   247,   247,   248,   249,   249,   250,   251,   250,   250,
     252,   253,   253,   254,   255,   256,   257,   258,   259,   260,
     261,   262,   262,   262,   263,   264,   264,   265,   265,   265,
     265,   265,   265,   266,   267,   267,   268,   268,   269,   270,
     270,   270,   270,   270,   270,   270,   270,   270,   271,   271,
     273,   272,   274,   274,   275,   276,   277,   277
};

/* YYR2[YYN] -- Number of symbols composing right hand side of rule YYN.  */
static const yytype_uint8 yyr2[] =
{
       0,     2,     1,     1,     0,     0,     0,    16,     1,     2,
       2,     1,     2,     2,     2,     1,     0,     1,     2,     5,
       1,     2,     5,     4,     7,     1,     0,     5,     1,     2,
       4,     3,     2,     2,     4,     1,     0,     1,     2,     4,
       3,     1,     2,     5,     3,     1,     2,     1,     1,     5,
       4,     1,     2,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     3,     5,     4,
       4,     4,     4,     2,     0,     4,     4,     1,     1,     6,
       4,     0,     3,     2,     3,     3,     3,     3,     3,     1,
       1,     2,     0,     1,     1,     1,     8,     7,     7,     7,
       1,     1,     1,     1,     7,     7,     7,     7,     8,     7,
       7,     7,     5,     7,     1,     1,     1,     1,     1,     7,
       7,     7,     7,     7,     3,     5,     4,     4,     5,     7,
       4,     1,     2,     3,     5,     4,     1,     0,     1,     2,
       1,     1,     5,     4,     3,     2,     3,     3,     1,     3,
       3,     3,     0,     4,     0,     4,     0,     4,     0,     4,
       0,     4,     0,     4,     0,     4,     0,     4,     0,     4,
       1,     0,     4,     0,     4,     2,     0,     4,     0,     4,
       3,     3,     3,     3,     3,     3,     1,     1,     1,     1,
       1,     1,     1,     2,     6,     4,     0,     1,     2,     3,
       1,     0,     1,     2,     1,     1,     1,     1,     3,     3,
       5,     3,     5,     3,     1,     0,     1,     2,     5,     3,
       1,     0,     1,     2,     4,     6,     1,     0,     1,     2,
       4,     1,     0,     1,     2,     4,     4,     1,     0,     1,
       2,     4,     4,     4,     1,     0,     1,     2,     6,     0,
       7,     4,     1,     6,     2,     0,     3,     1,     3,     1,
       1,     3,     1,     1,     1,     1,     1,     2,     2,     0,
       4,     1,     1,     1,     3,     1,     2,     4,     1,     2,
       1,     1,     2,     3,     1,     2,     1,     0,     3,     1,
       1,     1,     1,     1,     1,     1,     1,     3,     3,     2,
       4,     1,     1,     1,     2,     2,     1,     1,     1,     1,
       1,     1,     1,     4,     2,     1,     2,     3,     3,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     3,
       0,     6,     4,     0,     1,     1,     2,     0
};

/* YYDEFACT[STATE-NAME] -- Default reduction number in state STATE-NUM.
   Performed when YYTABLE doesn't specify something else to do.  Zero
   means the default is an error.  */
static const yytype_uint16 yydefact[] =
{
       4,     0,     0,     2,     0,     3,     0,   300,     0,     1,
       0,     0,     8,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,   344,     0,   322,   317,
     318,    66,    67,    68,    69,    70,    71,    72,   319,    73,
      74,    75,   124,   125,   126,   127,   128,    59,    60,    65,
      61,    62,    63,    64,    76,   309,   347,   316,   320,   321,
       0,   305,   262,   311,   313,   312,     0,    10,     0,     9,
      16,    11,    84,     0,     0,     0,     0,     0,    84,     0,
       0,     0,     0,     0,     0,    99,   100,     0,   272,   273,
       0,   276,     0,   275,   274,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,   347,   315,
     314,     0,   310,    13,     0,    12,     5,     0,    15,    17,
       0,     0,     0,     0,   270,   134,     0,     0,     0,     0,
      84,     0,    77,    87,    88,     0,     0,    93,     0,     0,
       0,     0,     0,     0,   102,   297,   299,     0,   294,   296,
     278,   277,     0,   279,     0,     0,     0,     0,     0,     0,
     141,     0,     0,     0,     0,     0,     0,   329,   332,   330,
     331,   334,   335,   336,   337,   333,     0,   325,     0,     0,
     308,     0,   346,     0,     0,    26,     0,    14,    20,    18,
       0,    83,   136,   145,     0,    32,    80,    81,    82,     0,
      79,    85,    86,    92,    94,    95,    96,    97,    98,     0,
       0,   293,   295,     0,     0,     0,     0,     0,     0,     0,
       0,   267,   269,   290,     0,   137,   142,     0,   140,     0,
       0,     0,     0,     0,   323,   324,   326,   338,     0,     0,
     340,     0,     0,     0,    25,     0,    28,     0,    21,   135,
     271,    78,     0,     0,     0,     0,     0,     0,     0,    91,
     101,   103,   104,   110,   111,   112,   113,   105,   298,     0,
     280,     0,     0,     0,   138,     0,   122,     0,     0,     0,
     143,     0,     0,     0,     0,     0,   328,   327,     0,   206,
     343,     0,   291,     0,     0,    58,     0,    51,    54,    53,
      55,    57,    56,     0,    29,    36,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,    89,     0,     0,     0,
       0,     0,   266,   268,     0,     0,     0,     0,     0,     0,
     339,     0,     0,   345,   341,     0,    19,   292,    31,     0,
       0,    52,   147,   202,     0,    33,     0,     0,    35,    37,
      23,     0,     0,     0,     0,     0,     0,     0,     0,   102,
     304,   119,     0,   120,   121,   139,   123,   144,   133,   129,
     130,   131,   132,     0,   204,     0,    30,   307,     0,     0,
       6,   146,   148,   150,   151,   203,     0,     0,     0,     0,
      41,    38,     0,    22,     0,     0,     0,     0,     0,     0,
       0,     0,   118,     0,     0,     0,     0,     0,   149,    34,
      40,     0,     0,     0,     0,    42,    27,    45,    47,    48,
       0,     0,     0,     0,     0,     0,     0,     0,    90,   205,
     342,     0,     0,     0,     0,   180,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,   158,     0,   225,   207,    39,    44,     0,     0,     0,
      46,    24,     0,     0,     0,     0,     0,     0,     0,     0,
     199,   200,   201,   196,   197,   198,   185,   181,   186,   183,
     188,   162,   164,   166,   168,     0,   170,   172,   174,   176,
     178,     0,     0,     0,   155,     0,     0,     0,   153,     0,
       0,   208,   248,   224,   226,     0,     0,     0,   107,     0,
     108,   109,   114,   115,   116,   117,   152,     0,     0,     0,
       0,   159,     0,     0,     0,     0,   160,     0,     0,   161,
       0,     0,     0,   190,   194,   191,   195,   192,   193,   154,
     156,   157,   209,     0,     0,     0,     0,     0,   255,   247,
     249,   227,    43,     0,    50,   106,     0,   281,   282,     0,
     285,   182,   283,   187,   184,   189,   163,   165,   167,   169,
     171,   173,   175,   177,   179,     0,     0,   302,   301,     0,
       0,     0,     0,   231,   254,   256,   250,    49,     0,   288,
       0,   286,     0,     0,     0,     0,     0,     0,     0,   211,
     237,   230,   232,   257,   284,   289,     0,     0,   228,   251,
     252,   253,   303,     0,     0,     0,     0,     0,     0,     7,
     210,   212,   214,   215,   216,   217,     0,   242,   236,   238,
     233,   287,   265,     0,   261,     0,     0,     0,     0,     0,
     213,     0,     0,   229,   241,   243,   239,     0,   263,   259,
       0,     0,   234,   218,     0,   219,     0,   221,   223,     0,
     306,     0,     0,   244,   264,     0,   258,     0,     0,     0,
     240,     0,     0,   260,   235,   220,   222,   245,   246
};

/* YYDEFGOTO[NTERM-NUM].  */
static const yytype_int16 yydefgoto[] =
{
      -1,     2,     3,     4,   195,   417,    11,    12,    80,    81,
     126,   127,   128,   129,   197,   198,   253,   254,   255,   256,
     137,   315,   357,   358,   359,   399,   400,   426,   427,   428,
     429,   306,   307,    39,    40,    41,    42,    43,    44,    45,
     132,    46,    47,   145,    48,   326,    94,    95,   219,   270,
     271,   272,   273,   274,   275,   276,    49,    50,    51,    52,
      53,    54,    55,    56,    57,    58,    59,    60,    61,    62,
     169,   170,    63,   390,   391,   392,   393,   394,   460,   461,
     532,   533,   534,   535,   537,   538,   540,   541,   542,   527,
     529,   528,   530,   485,   486,   352,   118,   342,   463,   464,
     629,   630,   631,   632,   633,   634,   635,   512,   513,   514,
     609,   610,   611,   612,   637,   638,   639,   653,   654,   655,
     558,   559,   560,   593,   594,   595,   675,    74,   552,   658,
     230,   231,   133,   100,   101,   102,   224,   569,   570,   571,
     598,   572,   301,   103,   157,   158,   220,   104,   589,   623,
     372,    75,   672,   311,    64,     5,     6,    76,    65,    66,
      67,    68,   186,   187,   188,   189,   248,    69,   300,   344,
      70,   345,   120
};

/* YYPACT[STATE-NUM] -- Index in YYTABLE of the portion describing
   STATE-NUM.  */
#define YYPACT_NINF -608
static const yytype_int16 yypact[] =
{
     -49,   -25,    68,  -608,   101,  -608,   515,  -608,   209,  -608,
     -25,    72,  -608,   -25,   -25,   -25,   -25,   -25,   -25,   -25,
     -25,   -25,   -25,   -10,    51,    51,    51,    51,    51,    58,
      51,    51,    51,    51,    51,    75,  -608,   -25,  -608,  -608,
    -608,  -608,  -608,  -608,  -608,  -608,  -608,  -608,  -608,  -608,
    -608,  -608,  -608,  -608,  -608,  -608,  -608,  -608,  -608,  -608,
    -608,  -608,  -608,  -608,  -608,  -608,   230,  -608,  -608,  -608,
     103,  -608,  -608,  -608,  -608,  -608,   127,  -608,   -25,  -608,
     256,  -608,    11,   -25,   169,   186,   -25,   -25,     6,   207,
     248,   248,   -10,   -10,   314,  -608,  -608,   120,  -608,  -608,
      -6,  -608,    51,  -608,   139,    51,    51,    51,    51,   312,
      51,    51,    51,    51,    51,   340,   236,   -25,   308,  -608,
    -608,   515,  -608,  -608,   -25,  -608,  -608,   335,   355,  -608,
      51,   -25,   284,    35,  -608,  -608,    51,   293,   259,   297,
     301,   306,  -608,  -608,  -608,   325,   344,   300,   -26,   -10,
     -10,   -10,   -10,   -10,  -608,  -608,  -608,   114,  -608,  -608,
    -608,  -608,   313,  -608,   319,   327,    38,   110,   385,    16,
    -608,   339,   277,   387,   392,   402,   -25,  -608,  -608,  -608,
    -608,  -608,  -608,  -608,  -608,  -608,    18,  -608,   408,   -25,
    -608,   499,  -608,   424,   427,   375,   -25,   335,  -608,  -608,
     433,   422,  -608,  -608,   -25,  -608,  -608,  -608,  -608,   438,
    -608,  -608,  -608,  -608,   300,   264,   217,  -608,  -608,   261,
     -25,  -608,  -608,    51,   -25,    51,    51,    51,   439,    51,
     444,   423,   449,  -608,   309,  -608,  -608,    51,  -608,    51,
      51,    51,    51,    51,  -608,  -608,  -608,  -608,   311,    51,
    -608,   -25,   -25,   718,  -608,   414,  -608,     0,  -608,  -608,
    -608,  -608,    51,    51,    51,    51,    51,    51,    51,   498,
    -608,  -608,  -608,  -608,  -608,  -608,  -608,  -608,  -608,   -25,
    -608,   -25,   -25,   -25,  -608,   -25,  -608,   -25,   -25,   312,
    -608,    51,    51,    51,    51,    51,  -608,  -608,   -25,   488,
     523,   115,  -608,    12,   -25,  -608,   426,  -608,  -608,  -608,
    -608,  -608,  -608,   144,  -608,   513,   -25,   -25,    51,    51,
      51,    51,    51,    51,    51,   456,  -608,     7,   455,   457,
     460,   467,  -608,   422,    17,   468,   473,   479,   480,   481,
    -608,   -25,   482,  -608,  -608,   458,  -608,  -608,  -608,   483,
     484,  -608,   136,  -608,   -25,  -608,   -25,   544,   513,  -608,
     491,   187,   485,   489,   494,   495,   496,   497,   500,  -608,
    -608,  -608,   502,  -608,  -608,  -608,  -608,  -608,  -608,  -608,
    -608,  -608,  -608,   557,  -608,   515,  -608,  -608,    51,    51,
    -608,   454,  -608,  -608,  -608,  -608,   197,    22,   -25,   338,
    -608,  -608,   -25,  -608,    51,    51,    51,    51,    51,    51,
      51,   290,  -608,   -25,   504,    51,   164,   590,  -608,  -608,
    -608,   506,   367,    51,    51,  -608,   443,  -608,  -608,  -608,
     203,   -25,   -25,   -25,    51,    51,    51,    51,  -608,  -608,
    -608,   164,   133,   152,   320,  -608,   428,   428,   428,   133,
     428,   428,   428,   428,   428,   133,   133,   133,   164,   164,
     -16,  -608,   -25,    27,  -608,  -608,  -608,   -25,    51,   164,
    -608,  -608,    20,   507,   512,   514,   516,   517,   518,    50,
    -608,  -608,  -608,  -608,  -608,  -608,  -608,  -608,  -608,  -608,
    -608,   546,  -608,  -608,   550,   551,  -608,  -608,   560,  -608,
    -608,   296,   552,   360,  -608,    -8,   164,   164,  -608,   -25,
     553,  -608,   328,   583,  -608,   361,   164,    65,  -608,   540,
    -608,  -608,  -608,  -608,  -608,  -608,  -608,   227,   227,   227,
     227,  -608,   227,   227,   227,   227,  -608,   227,   227,  -608,
     227,   227,   227,  -608,  -608,  -608,  -608,  -608,  -608,  -608,
    -608,   561,  -608,   541,   553,   174,   -25,   -25,   578,   328,
    -608,  -608,  -608,   128,  -608,  -608,   385,  -608,  -608,   231,
    -608,  -608,  -608,  -608,  -608,  -608,  -608,  -608,  -608,  -608,
    -608,  -608,  -608,  -608,  -608,   -25,   -25,  -608,  -608,   -25,
     -25,   -25,   174,   589,   578,  -608,  -608,  -608,   214,  -608,
     385,  -608,   545,   -25,   554,   555,   556,   646,   -25,   310,
     601,   589,  -608,  -608,  -608,  -608,   229,   -25,  -608,  -608,
    -608,  -608,  -608,    -2,   553,   553,   553,   553,   553,  -608,
     310,  -608,  -608,  -608,  -608,  -608,   -25,   603,   601,  -608,
    -608,  -608,   562,    98,  -608,   119,   -25,   163,   189,   -25,
    -608,   -25,   429,  -608,   603,  -608,  -608,   -25,  -608,  -608,
     -25,   553,  -608,  -608,   553,  -608,   553,  -608,  -608,   -25,
    -608,   569,   571,  -608,  -608,   -25,  -608,   -25,   -25,   -25,
    -608,   -25,   -25,  -608,  -608,  -608,  -608,  -608,  -608
};

/* YYPGOTO[NTERM-NUM].  */
static const yytype_int16 yypgoto[] =
{
    -608,  -608,  -608,  -608,  -608,  -608,  -608,   650,  -608,   582,
    -608,  -608,  -608,   535,  -608,   469,  -608,  -608,  -608,   409,
     -83,  -608,  -608,  -608,   307,  -608,   268,  -608,   243,  -608,
    -608,  -608,   364,  -209,  -199,  -608,  -608,  -608,  -608,  -608,
     -53,  -608,  -608,   580,  -188,  -608,    33,  -608,   303,  -608,
    -608,  -608,  -608,  -608,  -608,  -608,  -608,  -608,  -608,  -608,
    -608,  -608,  -608,  -608,  -608,  -608,  -608,  -608,  -608,  -608,
     384,  -161,  -608,  -608,  -608,   288,  -608,  -608,  -385,  -608,
    -608,  -608,  -608,  -608,  -608,  -608,  -608,  -608,  -608,  -608,
    -608,  -608,  -608,    28,  -111,  -608,  -258,  -608,  -608,   212,
    -608,  -608,    52,  -608,  -608,  -608,  -608,  -608,  -608,   170,
    -608,  -608,  -608,    74,  -608,  -608,    53,  -608,  -608,    39,
    -608,  -608,   130,  -608,  -608,   100,  -608,  -607,  -488,  -608,
    -284,  -253,   -84,  -114,   -31,   461,  -608,  -608,  -608,    91,
      92,  -164,  -291,   -51,  -608,   538,  -608,    -1,   104,  -608,
     225,  -487,    34,  -608,  -608,  -608,  -608,  -608,  -115,  -608,
     633,  -212,  -608,   519,  -608,  -608,  -608,  -182,  -608,  -608,
    -608,  -608,   591
};

/* YYTABLE[YYPACT[STATE-NUM]].  What to do in state STATE-NUM.  If
   positive, shift that token.  If negative, reduce the rule which
   number is the opposite.  If YYTABLE_NINF, syntax error.  */
#define YYTABLE_NINF -199
static const yytype_int16 yytable[] =
{
       8,   331,   138,   139,   234,   140,   193,   277,   236,    77,
     316,   370,    82,    83,    84,    85,    86,    87,    88,    89,
      90,    91,    96,   554,   370,   176,   361,   136,   168,   168,
     177,   130,   178,   136,   332,   141,   116,   179,   462,     1,
     180,   181,   182,   136,   308,   671,   156,   201,   353,   160,
     183,   149,   150,   151,   309,   184,   479,     7,   152,   153,
     185,   506,   507,   396,   681,   310,    92,   586,     9,   506,
     507,   312,     7,   504,   505,   213,     7,   123,   510,    10,
       7,   508,   134,    78,   517,   134,   134,   209,   383,    97,
      93,    96,    96,   549,   395,   317,   159,   308,   603,   161,
     643,   604,   605,   606,   371,   131,   156,   309,    10,   348,
     131,   430,   235,   377,   244,   618,   191,   518,   310,   420,
       7,   550,   551,   194,   312,   147,   148,   506,   507,   439,
     134,   563,   203,     7,   204,   644,   227,   645,   646,   647,
     648,   649,   506,   507,   388,   389,    97,   526,    96,    96,
      96,    96,    96,   109,    98,    99,   159,   662,   663,   665,
     667,   668,   564,   669,   487,   228,   232,   480,   481,   482,
     115,   488,   676,   236,   677,   243,   442,   678,   117,   679,
       7,   680,   214,   215,   216,   217,   218,   683,   247,   684,
     685,   686,     7,   687,   688,   257,     7,     7,   121,   277,
     659,     7,     7,   260,   333,   506,   507,   136,   229,    97,
     221,   346,   443,   444,   445,    97,   155,   483,   484,   278,
     349,   661,   155,   280,   122,   597,     7,   446,   447,   448,
     449,   450,   451,   452,   453,   454,   455,   456,   457,   354,
     458,   163,    13,    14,    15,     7,    16,    17,    18,    19,
     302,   303,    20,    21,    22,    23,   587,    24,    25,    26,
      27,    28,   124,    29,   459,   664,   135,    78,   588,     7,
     414,     7,   117,    30,    31,    32,    33,    34,   327,     7,
     328,   329,   330,   403,   232,     7,   232,   134,   262,   263,
     264,   666,    71,   419,   149,    72,   233,   340,    73,   471,
     347,   152,   153,   350,   142,   265,   266,   267,   268,   233,
     614,   233,   355,   233,   421,   360,   302,   262,   263,   264,
      35,    36,   566,    37,   168,   641,   600,    38,   143,   144,
      98,    99,   489,   190,   265,   266,   267,   268,   495,   490,
     232,   149,   196,   151,   501,   502,   503,   176,   152,   153,
     117,    35,   177,   302,   178,   397,   207,   269,   204,   179,
     347,   124,   180,   181,   182,   625,   626,   627,   628,   543,
     544,   545,   183,   674,   238,   239,   398,   184,   423,   424,
      35,   202,   185,   515,   152,   153,   438,   555,   556,   557,
     206,   149,   150,   151,   208,   347,   204,   422,   152,   153,
     131,   302,   599,   210,   289,   601,   290,   252,   297,   154,
     298,   223,   232,   567,   567,   567,   567,   225,   567,   567,
     567,   567,   211,   567,   567,   226,   567,   567,   567,   347,
     472,   473,   474,   547,   615,   548,   599,   237,    13,    14,
      15,   212,    16,    17,    18,    19,   252,   313,    20,    21,
      22,    23,   615,    24,    25,    26,    27,    28,   562,    29,
     204,   509,   388,   389,   466,   467,   134,   233,   117,    30,
      31,    32,    33,    34,   491,   492,   493,   494,   496,   497,
     498,   499,   500,   423,   424,   240,   105,   106,   107,   108,
     241,   110,   111,   112,   113,   114,   568,   568,   568,   568,
     242,   568,   568,   568,   568,   246,   568,   568,   553,   568,
     568,   568,   483,   484,   249,    72,   670,    36,   304,    37,
     250,   204,   251,   305,   325,   287,   341,    13,    14,    15,
     259,    16,    17,    18,    19,   261,   284,    20,    21,    22,
      23,   286,    24,    25,    26,    27,    28,   288,    29,   343,
     356,   369,   373,   385,   374,   590,   591,   375,    30,    31,
      32,    33,    34,   162,   376,   378,   164,   165,   166,   167,
     379,   171,   172,   173,   174,   175,   380,   381,   382,   384,
     386,   387,   398,   404,   602,   553,   402,   405,   553,   553,
     553,   200,   406,   407,   408,   409,   413,   205,   410,   412,
     440,   462,   553,   465,   520,    35,    36,   624,    37,   521,
     531,   522,    38,   523,   524,   525,   642,  -198,   536,   573,
     574,   575,   553,   576,   577,   578,   579,   546,   580,   581,
     539,   582,   583,   584,   510,   651,    71,   565,   506,   585,
     592,   608,   660,   617,   553,   553,   553,   553,   553,   622,
     553,   619,   620,   621,   636,    72,   232,   652,   670,   553,
     657,    79,   125,   199,   314,   401,   258,   425,   553,   470,
     351,   146,   411,   334,   553,   511,   553,   553,   553,   418,
     553,   553,   650,   561,   279,   640,   281,   282,   283,   596,
     285,   656,   616,   673,   613,   222,   607,   519,   291,   119,
     292,   293,   294,   295,   296,   245,   682,     0,     0,   192,
     299,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,   318,   319,   320,   321,   322,   323,   324,
      13,    14,    15,     0,    16,    17,    18,    19,     0,     0,
      20,    21,    22,    23,     0,    24,    25,    26,    27,    28,
       0,    29,   335,   336,   337,   338,   339,     0,     0,     0,
       0,    30,    31,    32,    33,    34,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,   362,
     363,   364,   365,   366,   367,   368,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,    36,
     304,    37,     0,     0,     0,   305,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,   415,
     416,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,   431,   432,   433,   434,   435,
     436,   437,     0,     0,     0,     0,   441,     0,     0,     0,
       0,     0,     0,     0,   468,   469,     0,     0,     0,     0,
       0,     0,     0,     0,     0,   475,   476,   477,   478,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,   516
};

#define yypact_value_is_default(yystate) \
  ((yystate) == (-608))

#define yytable_value_is_error(yytable_value) \
  YYID (0)

static const yytype_int16 yycheck[] =
{
       1,   285,    86,    87,   168,    88,   121,   219,   169,    10,
      10,     4,    13,    14,    15,    16,    17,    18,    19,    20,
      21,    22,    23,   510,     4,     7,   317,    21,    12,    12,
      12,    20,    14,    21,   287,    88,    37,    19,    11,    88,
      22,    23,    24,    21,   253,   652,    97,   131,   306,   100,
      32,    77,    78,    79,   253,    37,   441,    82,    84,    85,
      42,    77,    78,   354,   671,   253,    76,   554,     0,    77,
      78,   253,    82,   458,   459,   101,    82,    78,    51,     7,
      82,    97,    83,    11,   469,    86,    87,   140,   341,    95,
     100,    92,    93,   101,   352,    95,    97,   306,   586,   100,
     102,   589,   590,   591,    97,    99,   157,   306,     7,    97,
      99,   402,    96,    96,    96,   603,   117,    97,   306,    97,
      82,   506,   507,   124,   306,    92,    93,    77,    78,   413,
     131,   516,    97,    82,    99,   623,    98,   624,   625,   626,
     627,   628,    77,    78,     8,     9,    95,    97,   149,   150,
     151,   152,   153,    95,   103,   104,   157,   645,   646,   647,
     648,   649,    97,   651,    12,   166,   167,    34,    35,    36,
      95,    19,   660,   334,   661,   176,    12,   664,    42,   666,
      82,   669,   149,   150,   151,   152,   153,   675,   189,   677,
     678,   679,    82,   681,   682,   196,    82,    82,    95,   411,
     102,    82,    82,   204,   288,    77,    78,    21,    98,    95,
      96,    96,    48,    49,    50,    95,   102,    84,    85,   220,
     303,   102,   102,   224,    97,    97,    82,    63,    64,    65,
      66,    67,    68,    69,    70,    71,    72,    73,    74,    95,
      76,   102,    12,    13,    14,    82,    16,    17,    18,    19,
     251,   252,    22,    23,    24,    25,    82,    27,    28,    29,
      30,    31,     6,    33,   100,   102,    97,    11,    94,    82,
     385,    82,    42,    43,    44,    45,    46,    47,   279,    82,
     281,   282,   283,    96,   285,    82,   287,   288,    27,    28,
      29,   102,    83,    96,    77,    86,    82,   298,    89,    96,
     301,    84,    85,   304,    97,    44,    45,    46,    47,    82,
      96,    82,   313,    82,   397,   316,   317,    27,    28,    29,
      90,    91,    95,    93,    12,    96,    95,    97,    80,    81,
     103,   104,    12,    97,    44,    45,    46,    47,   449,    19,
     341,    77,     7,    79,   455,   456,   457,     7,    84,    85,
      42,    90,    12,   354,    14,   356,    97,    96,    99,    19,
     361,     6,    22,    23,    24,    55,    56,    57,    58,    73,
      74,    75,    32,   657,    97,    98,    38,    37,    40,    41,
      90,    97,    42,   467,    84,    85,    96,    59,    60,    61,
      97,    77,    78,    79,    97,   396,    99,   398,    84,    85,
      99,   402,   566,    97,    95,   569,    97,    32,    97,    95,
      99,    98,   413,   527,   528,   529,   530,    98,   532,   533,
     534,   535,    97,   537,   538,    98,   540,   541,   542,   430,
     431,   432,   433,    73,   598,    75,   600,    98,    12,    13,
      14,    97,    16,    17,    18,    19,    32,    33,    22,    23,
      24,    25,   616,    27,    28,    29,    30,    31,    97,    33,
      99,   462,     8,     9,    97,    98,   467,    82,    42,    43,
      44,    45,    46,    47,   446,   447,   448,   449,   450,   451,
     452,   453,   454,    40,    41,    98,    25,    26,    27,    28,
      98,    30,    31,    32,    33,    34,   527,   528,   529,   530,
      98,   532,   533,   534,   535,    97,   537,   538,   509,   540,
     541,   542,    84,    85,    15,    86,    87,    91,    92,    93,
      96,    99,    95,    97,    26,   102,    38,    12,    13,    14,
      97,    16,    17,    18,    19,    97,    97,    22,    23,    24,
      25,    97,    27,    28,    29,    30,    31,    98,    33,    26,
      37,    95,    97,    95,    97,   556,   557,    97,    43,    44,
      45,    46,    47,   102,    97,    97,   105,   106,   107,   108,
      97,   110,   111,   112,   113,   114,    97,    97,    97,    97,
      97,    97,    38,    98,   585,   586,    95,    98,   589,   590,
     591,   130,    98,    98,    98,    98,    39,   136,    98,    97,
      96,    11,   603,    97,    97,    90,    91,   608,    93,    97,
      64,    97,    97,    97,    97,    97,   617,    67,    67,   528,
     529,   530,   623,   532,   533,   534,   535,    75,   537,   538,
      70,   540,   541,   542,    51,   636,    83,    97,    77,    98,
      62,    52,   643,    98,   645,   646,   647,   648,   649,     3,
     651,    97,    97,    97,    53,    86,   657,    54,    87,   660,
      98,    11,    80,   128,   255,   358,   197,   399,   669,   426,
     306,    91,   369,   289,   675,   463,   677,   678,   679,   391,
     681,   682,   630,   513,   223,   611,   225,   226,   227,   559,
     229,   638,   600,   654,   594,   157,   592,   472,   237,    66,
     239,   240,   241,   242,   243,   186,   672,    -1,    -1,   118,
     249,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,   262,   263,   264,   265,   266,   267,   268,
      12,    13,    14,    -1,    16,    17,    18,    19,    -1,    -1,
      22,    23,    24,    25,    -1,    27,    28,    29,    30,    31,
      -1,    33,   291,   292,   293,   294,   295,    -1,    -1,    -1,
      -1,    43,    44,    45,    46,    47,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   318,
     319,   320,   321,   322,   323,   324,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    91,
      92,    93,    -1,    -1,    -1,    97,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   388,
     389,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,   404,   405,   406,   407,   408,
     409,   410,    -1,    -1,    -1,    -1,   415,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,   423,   424,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,   434,   435,   436,   437,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   468
};

/* YYSTOS[STATE-NUM] -- The (internal number of the) accessing
   symbol of state STATE-NUM.  */
static const yytype_uint16 yystos[] =
{
       0,    88,   106,   107,   108,   260,   261,    82,   252,     0,
       7,   111,   112,    12,    13,    14,    16,    17,    18,    19,
      22,    23,    24,    25,    27,    28,    29,    30,    31,    33,
      43,    44,    45,    46,    47,    90,    91,    93,    97,   138,
     139,   140,   141,   142,   143,   144,   146,   147,   149,   161,
     162,   163,   164,   165,   166,   167,   168,   169,   170,   171,
     172,   173,   174,   177,   259,   263,   264,   265,   266,   272,
     275,    83,    86,    89,   232,   256,   262,   252,    11,   112,
     113,   114,   252,   252,   252,   252,   252,   252,   252,   252,
     252,   252,    76,   100,   151,   152,   252,    95,   103,   104,
     238,   239,   240,   248,   252,   240,   240,   240,   240,    95,
     240,   240,   240,   240,   240,    95,   252,    42,   201,   265,
     277,    95,    97,   252,     6,   114,   115,   116,   117,   118,
      20,    99,   145,   237,   252,    97,    21,   125,   237,   237,
     125,   145,    97,    80,    81,   148,   148,   151,   151,    77,
      78,    79,    84,    85,    95,   102,   248,   249,   250,   252,
     248,   252,   240,   102,   240,   240,   240,   240,    12,   175,
     176,   240,   240,   240,   240,   240,     7,    12,    14,    19,
      22,    23,    24,    32,    37,    42,   267,   268,   269,   270,
      97,   252,   277,   263,   252,   109,     7,   119,   120,   118,
     240,   237,    97,    97,    99,   240,    97,    97,    97,   145,
      97,    97,    97,   101,   151,   151,   151,   151,   151,   153,
     251,    96,   250,    98,   241,    98,    98,    98,   252,    98,
     235,   236,   252,    82,   246,    96,   176,    98,    97,    98,
      98,    98,    98,   252,    96,   268,    97,   252,   271,    15,
      96,    95,    32,   121,   122,   123,   124,   252,   120,    97,
     252,    97,    27,    28,    29,    44,    45,    46,    47,    96,
     154,   155,   156,   157,   158,   159,   160,   266,   252,   240,
     252,   240,   240,   240,    97,   240,    97,   102,    98,    95,
      97,   240,   240,   240,   240,   240,   240,    97,    99,   240,
     273,   247,   252,   252,    92,    97,   136,   137,   138,   139,
     149,   258,   272,    33,   124,   126,    10,    95,   240,   240,
     240,   240,   240,   240,   240,    26,   150,   252,   252,   252,
     252,   235,   236,   237,   175,   240,   240,   240,   240,   240,
     252,    38,   202,    26,   274,   276,    96,   252,    97,   125,
     252,   137,   200,   201,    95,   252,    37,   127,   128,   129,
     252,   247,   240,   240,   240,   240,   240,   240,   240,    95,
       4,    97,   255,    97,    97,    97,    97,    96,    97,    97,
      97,    97,    97,   236,    97,    95,    97,    97,     8,     9,
     178,   179,   180,   181,   182,   201,   247,   252,    38,   130,
     131,   129,    95,    96,    98,    98,    98,    98,    98,    98,
      98,   153,    97,    39,   263,   240,   240,   110,   180,    96,
      97,   125,   252,    40,    41,   131,   132,   133,   134,   135,
     247,   240,   240,   240,   240,   240,   240,   240,    96,   235,
      96,   240,    12,    48,    49,    50,    63,    64,    65,    66,
      67,    68,    69,    70,    71,    72,    73,    74,    76,   100,
     183,   184,    11,   203,   204,    97,    97,    98,   240,   240,
     133,    96,   252,   252,   252,   240,   240,   240,   240,   183,
      34,    35,    36,    84,    85,   198,   199,    12,    19,    12,
      19,   198,   198,   198,   198,   199,   198,   198,   198,   198,
     198,   199,   199,   199,   183,   183,    77,    78,    97,   252,
      51,   204,   212,   213,   214,   237,   240,   183,    97,   255,
      97,    97,    97,    97,    97,    97,    97,   194,   196,   195,
     197,    64,   185,   186,   187,   188,    67,   189,   190,    70,
     191,   192,   193,    73,    74,    75,    75,    73,    75,   101,
     183,   183,   233,   252,   256,    59,    60,    61,   225,   226,
     227,   214,    97,   183,    97,    97,    95,   238,   239,   242,
     243,   244,   246,   244,   244,   244,   244,   244,   244,   244,
     244,   244,   244,   244,   244,    98,   256,    82,    94,   253,
     252,   252,    62,   228,   229,   230,   227,    97,   245,   246,
      95,   246,   252,   233,   233,   233,   233,   253,    52,   215,
     216,   217,   218,   230,    96,   246,   245,    98,   233,    97,
      97,    97,     3,   254,   252,    55,    56,    57,    58,   205,
     206,   207,   208,   209,   210,   211,    53,   219,   220,   221,
     218,    96,   252,   102,   233,   256,   256,   256,   256,   256,
     207,   252,    54,   222,   223,   224,   221,    98,   234,   102,
     252,   102,   233,   233,   102,   233,   102,   233,   233,   233,
      87,   232,   257,   224,   235,   231,   233,   256,   256,   256,
     233,   232,   257,   233,   233,   233,   233,   233,   233
};

#define yyerrok		(yyerrstatus = 0)
#define yyclearin	(yychar = YYEMPTY)
#define YYEMPTY		(-2)
#define YYEOF		0

#define YYACCEPT	goto yyacceptlab
#define YYABORT		goto yyabortlab
#define YYERROR		goto yyerrorlab


/* Like YYERROR except do call yyerror.  This remains here temporarily
   to ease the transition to the new meaning of YYERROR, for GCC.
   Once GCC version 2 has supplanted version 1, this can go.  However,
   YYFAIL appears to be in use.  Nevertheless, it is formally deprecated
   in Bison 2.4.2's NEWS entry, where a plan to phase it out is
   discussed.  */

#define YYFAIL		goto yyerrlab
#if defined YYFAIL
  /* This is here to suppress warnings from the GCC cpp's
     -Wunused-macros.  Normally we don't worry about that warning, but
     some users do, and we want to make it easy for users to remove
     YYFAIL uses, which will produce warnings from Bison 2.5.  */
#endif

#define YYRECOVERING()  (!!yyerrstatus)

#define YYBACKUP(Token, Value)					\
do								\
  if (yychar == YYEMPTY && yylen == 1)				\
    {								\
      yychar = (Token);						\
      yylval = (Value);						\
      YYPOPSTACK (1);						\
      goto yybackup;						\
    }								\
  else								\
    {								\
      yyerror (YY_("syntax error: cannot back up")); \
      YYERROR;							\
    }								\
while (YYID (0))


#define YYTERROR	1
#define YYERRCODE	256


/* YYLLOC_DEFAULT -- Set CURRENT to span from RHS[1] to RHS[N].
   If N is 0, then set CURRENT to the empty location which ends
   the previous symbol: RHS[0] (always defined).  */

#define YYRHSLOC(Rhs, K) ((Rhs)[K])
#ifndef YYLLOC_DEFAULT
# define YYLLOC_DEFAULT(Current, Rhs, N)				\
    do									\
      if (YYID (N))                                                    \
	{								\
	  (Current).first_line   = YYRHSLOC (Rhs, 1).first_line;	\
	  (Current).first_column = YYRHSLOC (Rhs, 1).first_column;	\
	  (Current).last_line    = YYRHSLOC (Rhs, N).last_line;		\
	  (Current).last_column  = YYRHSLOC (Rhs, N).last_column;	\
	}								\
      else								\
	{								\
	  (Current).first_line   = (Current).last_line   =		\
	    YYRHSLOC (Rhs, 0).last_line;				\
	  (Current).first_column = (Current).last_column =		\
	    YYRHSLOC (Rhs, 0).last_column;				\
	}								\
    while (YYID (0))
#endif


/* This macro is provided for backward compatibility. */

#ifndef YY_LOCATION_PRINT
# define YY_LOCATION_PRINT(File, Loc) ((void) 0)
#endif


/* YYLEX -- calling `yylex' with the right arguments.  */

#ifdef YYLEX_PARAM
# define YYLEX yylex (YYLEX_PARAM)
#else
# define YYLEX yylex ()
#endif

/* Enable debugging if requested.  */
#if YYDEBUG

# ifndef YYFPRINTF
#  include <stdio.h> /* INFRINGES ON USER NAME SPACE */
#  define YYFPRINTF fprintf
# endif

# define YYDPRINTF(Args)			\
do {						\
  if (yydebug)					\
    YYFPRINTF Args;				\
} while (YYID (0))

# define YY_SYMBOL_PRINT(Title, Type, Value, Location)			  \
do {									  \
  if (yydebug)								  \
    {									  \
      YYFPRINTF (stderr, "%s ", Title);					  \
      yy_symbol_print (stderr,						  \
		  Type, Value); \
      YYFPRINTF (stderr, "\n");						  \
    }									  \
} while (YYID (0))


/*--------------------------------.
| Print this symbol on YYOUTPUT.  |
`--------------------------------*/

/*ARGSUSED*/
#if (defined __STDC__ || defined __C99__FUNC__ \
     || defined __cplusplus || defined _MSC_VER)
static void
yy_symbol_value_print (FILE *yyoutput, int yytype, YYSTYPE const * const yyvaluep)
#else
static void
yy_symbol_value_print (yyoutput, yytype, yyvaluep)
    FILE *yyoutput;
    int yytype;
    YYSTYPE const * const yyvaluep;
#endif
{
  if (!yyvaluep)
    return;
# ifdef YYPRINT
  if (yytype < YYNTOKENS)
    YYPRINT (yyoutput, yytoknum[yytype], *yyvaluep);
# else
  YYUSE (yyoutput);
# endif
  switch (yytype)
    {
      default:
	break;
    }
}


/*--------------------------------.
| Print this symbol on YYOUTPUT.  |
`--------------------------------*/

#if (defined __STDC__ || defined __C99__FUNC__ \
     || defined __cplusplus || defined _MSC_VER)
static void
yy_symbol_print (FILE *yyoutput, int yytype, YYSTYPE const * const yyvaluep)
#else
static void
yy_symbol_print (yyoutput, yytype, yyvaluep)
    FILE *yyoutput;
    int yytype;
    YYSTYPE const * const yyvaluep;
#endif
{
  if (yytype < YYNTOKENS)
    YYFPRINTF (yyoutput, "token %s (", yytname[yytype]);
  else
    YYFPRINTF (yyoutput, "nterm %s (", yytname[yytype]);

  yy_symbol_value_print (yyoutput, yytype, yyvaluep);
  YYFPRINTF (yyoutput, ")");
}

/*------------------------------------------------------------------.
| yy_stack_print -- Print the state stack from its BOTTOM up to its |
| TOP (included).                                                   |
`------------------------------------------------------------------*/

#if (defined __STDC__ || defined __C99__FUNC__ \
     || defined __cplusplus || defined _MSC_VER)
static void
yy_stack_print (yytype_int16 *yybottom, yytype_int16 *yytop)
#else
static void
yy_stack_print (yybottom, yytop)
    yytype_int16 *yybottom;
    yytype_int16 *yytop;
#endif
{
  YYFPRINTF (stderr, "Stack now");
  for (; yybottom <= yytop; yybottom++)
    {
      int yybot = *yybottom;
      YYFPRINTF (stderr, " %d", yybot);
    }
  YYFPRINTF (stderr, "\n");
}

# define YY_STACK_PRINT(Bottom, Top)				\
do {								\
  if (yydebug)							\
    yy_stack_print ((Bottom), (Top));				\
} while (YYID (0))


/*------------------------------------------------.
| Report that the YYRULE is going to be reduced.  |
`------------------------------------------------*/

#if (defined __STDC__ || defined __C99__FUNC__ \
     || defined __cplusplus || defined _MSC_VER)
static void
yy_reduce_print (YYSTYPE *yyvsp, int yyrule)
#else
static void
yy_reduce_print (yyvsp, yyrule)
    YYSTYPE *yyvsp;
    int yyrule;
#endif
{
  int yynrhs = yyr2[yyrule];
  int yyi;
  unsigned long int yylno = yyrline[yyrule];
  YYFPRINTF (stderr, "Reducing stack by rule %d (line %lu):\n",
	     yyrule - 1, yylno);
  /* The symbols being reduced.  */
  for (yyi = 0; yyi < yynrhs; yyi++)
    {
      YYFPRINTF (stderr, "   $%d = ", yyi + 1);
      yy_symbol_print (stderr, yyrhs[yyprhs[yyrule] + yyi],
		       &(yyvsp[(yyi + 1) - (yynrhs)])
		       		       );
      YYFPRINTF (stderr, "\n");
    }
}

# define YY_REDUCE_PRINT(Rule)		\
do {					\
  if (yydebug)				\
    yy_reduce_print (yyvsp, Rule); \
} while (YYID (0))

/* Nonzero means print parse trace.  It is left uninitialized so that
   multiple parsers can coexist.  */
int yydebug;
#else /* !YYDEBUG */
# define YYDPRINTF(Args)
# define YY_SYMBOL_PRINT(Title, Type, Value, Location)
# define YY_STACK_PRINT(Bottom, Top)
# define YY_REDUCE_PRINT(Rule)
#endif /* !YYDEBUG */


/* YYINITDEPTH -- initial size of the parser's stacks.  */
#ifndef	YYINITDEPTH
# define YYINITDEPTH 200
#endif

/* YYMAXDEPTH -- maximum size the stacks can grow to (effective only
   if the built-in stack extension method is used).

   Do not make this value too large; the results are undefined if
   YYSTACK_ALLOC_MAXIMUM < YYSTACK_BYTES (YYMAXDEPTH)
   evaluated with infinite-precision integer arithmetic.  */

#ifndef YYMAXDEPTH
# define YYMAXDEPTH 10000
#endif


#if YYERROR_VERBOSE

# ifndef yystrlen
#  if defined __GLIBC__ && defined _STRING_H
#   define yystrlen strlen
#  else
/* Return the length of YYSTR.  */
#if (defined __STDC__ || defined __C99__FUNC__ \
     || defined __cplusplus || defined _MSC_VER)
static YYSIZE_T
yystrlen (const char *yystr)
#else
static YYSIZE_T
yystrlen (yystr)
    const char *yystr;
#endif
{
  YYSIZE_T yylen;
  for (yylen = 0; yystr[yylen]; yylen++)
    continue;
  return yylen;
}
#  endif
# endif

# ifndef yystpcpy
#  if defined __GLIBC__ && defined _STRING_H && defined _GNU_SOURCE
#   define yystpcpy stpcpy
#  else
/* Copy YYSRC to YYDEST, returning the address of the terminating '\0' in
   YYDEST.  */
#if (defined __STDC__ || defined __C99__FUNC__ \
     || defined __cplusplus || defined _MSC_VER)
static char *
yystpcpy (char *yydest, const char *yysrc)
#else
static char *
yystpcpy (yydest, yysrc)
    char *yydest;
    const char *yysrc;
#endif
{
  char *yyd = yydest;
  const char *yys = yysrc;

  while ((*yyd++ = *yys++) != '\0')
    continue;

  return yyd - 1;
}
#  endif
# endif

# ifndef yytnamerr
/* Copy to YYRES the contents of YYSTR after stripping away unnecessary
   quotes and backslashes, so that it's suitable for yyerror.  The
   heuristic is that double-quoting is unnecessary unless the string
   contains an apostrophe, a comma, or backslash (other than
   backslash-backslash).  YYSTR is taken from yytname.  If YYRES is
   null, do not copy; instead, return the length of what the result
   would have been.  */
static YYSIZE_T
yytnamerr (char *yyres, const char *yystr)
{
  if (*yystr == '"')
    {
      YYSIZE_T yyn = 0;
      char const *yyp = yystr;

      for (;;)
	switch (*++yyp)
	  {
	  case '\'':
	  case ',':
	    goto do_not_strip_quotes;

	  case '\\':
	    if (*++yyp != '\\')
	      goto do_not_strip_quotes;
	    /* Fall through.  */
	  default:
	    if (yyres)
	      yyres[yyn] = *yyp;
	    yyn++;
	    break;

	  case '"':
	    if (yyres)
	      yyres[yyn] = '\0';
	    return yyn;
	  }
    do_not_strip_quotes: ;
    }

  if (! yyres)
    return yystrlen (yystr);

  return yystpcpy (yyres, yystr) - yyres;
}
# endif

/* Copy into *YYMSG, which is of size *YYMSG_ALLOC, an error message
   about the unexpected token YYTOKEN for the state stack whose top is
   YYSSP.

   Return 0 if *YYMSG was successfully written.  Return 1 if *YYMSG is
   not large enough to hold the message.  In that case, also set
   *YYMSG_ALLOC to the required number of bytes.  Return 2 if the
   required number of bytes is too large to store.  */
static int
yysyntax_error (YYSIZE_T *yymsg_alloc, char **yymsg,
                yytype_int16 *yyssp, int yytoken)
{
  YYSIZE_T yysize0 = yytnamerr (0, yytname[yytoken]);
  YYSIZE_T yysize = yysize0;
  YYSIZE_T yysize1;
  enum { YYERROR_VERBOSE_ARGS_MAXIMUM = 5 };
  /* Internationalized format string. */
  const char *yyformat = 0;
  /* Arguments of yyformat. */
  char const *yyarg[YYERROR_VERBOSE_ARGS_MAXIMUM];
  /* Number of reported tokens (one for the "unexpected", one per
     "expected"). */
  int yycount = 0;

  /* There are many possibilities here to consider:
     - Assume YYFAIL is not used.  It's too flawed to consider.  See
       <http://lists.gnu.org/archive/html/bison-patches/2009-12/msg00024.html>
       for details.  YYERROR is fine as it does not invoke this
       function.
     - If this state is a consistent state with a default action, then
       the only way this function was invoked is if the default action
       is an error action.  In that case, don't check for expected
       tokens because there are none.
     - The only way there can be no lookahead present (in yychar) is if
       this state is a consistent state with a default action.  Thus,
       detecting the absence of a lookahead is sufficient to determine
       that there is no unexpected or expected token to report.  In that
       case, just report a simple "syntax error".
     - Don't assume there isn't a lookahead just because this state is a
       consistent state with a default action.  There might have been a
       previous inconsistent state, consistent state with a non-default
       action, or user semantic action that manipulated yychar.
     - Of course, the expected token list depends on states to have
       correct lookahead information, and it depends on the parser not
       to perform extra reductions after fetching a lookahead from the
       scanner and before detecting a syntax error.  Thus, state merging
       (from LALR or IELR) and default reductions corrupt the expected
       token list.  However, the list is correct for canonical LR with
       one exception: it will still contain any token that will not be
       accepted due to an error action in a later state.
  */
  if (yytoken != YYEMPTY)
    {
      int yyn = yypact[*yyssp];
      yyarg[yycount++] = yytname[yytoken];
      if (!yypact_value_is_default (yyn))
        {
          /* Start YYX at -YYN if negative to avoid negative indexes in
             YYCHECK.  In other words, skip the first -YYN actions for
             this state because they are default actions.  */
          int yyxbegin = yyn < 0 ? -yyn : 0;
          /* Stay within bounds of both yycheck and yytname.  */
          int yychecklim = YYLAST - yyn + 1;
          int yyxend = yychecklim < YYNTOKENS ? yychecklim : YYNTOKENS;
          int yyx;

          for (yyx = yyxbegin; yyx < yyxend; ++yyx)
            if (yycheck[yyx + yyn] == yyx && yyx != YYTERROR
                && !yytable_value_is_error (yytable[yyx + yyn]))
              {
                if (yycount == YYERROR_VERBOSE_ARGS_MAXIMUM)
                  {
                    yycount = 1;
                    yysize = yysize0;
                    break;
                  }
                yyarg[yycount++] = yytname[yyx];
                yysize1 = yysize + yytnamerr (0, yytname[yyx]);
                if (! (yysize <= yysize1
                       && yysize1 <= YYSTACK_ALLOC_MAXIMUM))
                  return 2;
                yysize = yysize1;
              }
        }
    }

  switch (yycount)
    {
# define YYCASE_(N, S)                      \
      case N:                               \
        yyformat = S;                       \
      break
      YYCASE_(0, YY_("syntax error"));
      YYCASE_(1, YY_("syntax error, unexpected %s"));
      YYCASE_(2, YY_("syntax error, unexpected %s, expecting %s"));
      YYCASE_(3, YY_("syntax error, unexpected %s, expecting %s or %s"));
      YYCASE_(4, YY_("syntax error, unexpected %s, expecting %s or %s or %s"));
      YYCASE_(5, YY_("syntax error, unexpected %s, expecting %s or %s or %s or %s"));
# undef YYCASE_
    }

  yysize1 = yysize + yystrlen (yyformat);
  if (! (yysize <= yysize1 && yysize1 <= YYSTACK_ALLOC_MAXIMUM))
    return 2;
  yysize = yysize1;

  if (*yymsg_alloc < yysize)
    {
      *yymsg_alloc = 2 * yysize;
      if (! (yysize <= *yymsg_alloc
             && *yymsg_alloc <= YYSTACK_ALLOC_MAXIMUM))
        *yymsg_alloc = YYSTACK_ALLOC_MAXIMUM;
      return 1;
    }

  /* Avoid sprintf, as that infringes on the user's name space.
     Don't have undefined behavior even if the translation
     produced a string with the wrong number of "%s"s.  */
  {
    char *yyp = *yymsg;
    int yyi = 0;
    while ((*yyp = *yyformat) != '\0')
      if (*yyp == '%' && yyformat[1] == 's' && yyi < yycount)
        {
          yyp += yytnamerr (yyp, yyarg[yyi++]);
          yyformat += 2;
        }
      else
        {
          yyp++;
          yyformat++;
        }
  }
  return 0;
}
#endif /* YYERROR_VERBOSE */

/*-----------------------------------------------.
| Release the memory associated to this symbol.  |
`-----------------------------------------------*/

/*ARGSUSED*/
#if (defined __STDC__ || defined __C99__FUNC__ \
     || defined __cplusplus || defined _MSC_VER)
static void
yydestruct (const char *yymsg, int yytype, YYSTYPE *yyvaluep)
#else
static void
yydestruct (yymsg, yytype, yyvaluep)
    const char *yymsg;
    int yytype;
    YYSTYPE *yyvaluep;
#endif
{
  YYUSE (yyvaluep);

  if (!yymsg)
    yymsg = "Deleting";
  YY_SYMBOL_PRINT (yymsg, yytype, yyvaluep, yylocationp);

  switch (yytype)
    {

      default:
	break;
    }
}


/* Prevent warnings from -Wmissing-prototypes.  */
#ifdef YYPARSE_PARAM
#if defined __STDC__ || defined __cplusplus
int yyparse (void *YYPARSE_PARAM);
#else
int yyparse ();
#endif
#else /* ! YYPARSE_PARAM */
#if defined __STDC__ || defined __cplusplus
int yyparse (void);
#else
int yyparse ();
#endif
#endif /* ! YYPARSE_PARAM */


/* The lookahead symbol.  */
int yychar;

/* The semantic value of the lookahead symbol.  */
YYSTYPE yylval;

/* Number of syntax errors so far.  */
int yynerrs;


/*----------.
| yyparse.  |
`----------*/

#ifdef YYPARSE_PARAM
#if (defined __STDC__ || defined __C99__FUNC__ \
     || defined __cplusplus || defined _MSC_VER)
int
yyparse (void *YYPARSE_PARAM)
#else
int
yyparse (YYPARSE_PARAM)
    void *YYPARSE_PARAM;
#endif
#else /* ! YYPARSE_PARAM */
#if (defined __STDC__ || defined __C99__FUNC__ \
     || defined __cplusplus || defined _MSC_VER)
int
yyparse (void)
#else
int
yyparse ()

#endif
#endif
{
    int yystate;
    /* Number of tokens to shift before error messages enabled.  */
    int yyerrstatus;

    /* The stacks and their tools:
       `yyss': related to states.
       `yyvs': related to semantic values.

       Refer to the stacks thru separate pointers, to allow yyoverflow
       to reallocate them elsewhere.  */

    /* The state stack.  */
    yytype_int16 yyssa[YYINITDEPTH];
    yytype_int16 *yyss;
    yytype_int16 *yyssp;

    /* The semantic value stack.  */
    YYSTYPE yyvsa[YYINITDEPTH];
    YYSTYPE *yyvs;
    YYSTYPE *yyvsp;

    YYSIZE_T yystacksize;

  int yyn;
  int yyresult;
  /* Lookahead token as an internal (translated) token number.  */
  int yytoken;
  /* The variables used to return semantic value and location from the
     action routines.  */
  YYSTYPE yyval;

#if YYERROR_VERBOSE
  /* Buffer for error messages, and its allocated size.  */
  char yymsgbuf[128];
  char *yymsg = yymsgbuf;
  YYSIZE_T yymsg_alloc = sizeof yymsgbuf;
#endif

#define YYPOPSTACK(N)   (yyvsp -= (N), yyssp -= (N))

  /* The number of symbols on the RHS of the reduced rule.
     Keep to zero when no symbol should be popped.  */
  int yylen = 0;

  yytoken = 0;
  yyss = yyssa;
  yyvs = yyvsa;
  yystacksize = YYINITDEPTH;

  YYDPRINTF ((stderr, "Starting parse\n"));

  yystate = 0;
  yyerrstatus = 0;
  yynerrs = 0;
  yychar = YYEMPTY; /* Cause a token to be read.  */

  /* Initialize stack pointers.
     Waste one element of value and location stack
     so that they stay on the same level as the state stack.
     The wasted elements are never initialized.  */
  yyssp = yyss;
  yyvsp = yyvs;

  goto yysetstate;

/*------------------------------------------------------------.
| yynewstate -- Push a new state, which is found in yystate.  |
`------------------------------------------------------------*/
 yynewstate:
  /* In all cases, when you get here, the value and location stacks
     have just been pushed.  So pushing a state here evens the stacks.  */
  yyssp++;

 yysetstate:
  *yyssp = yystate;

  if (yyss + yystacksize - 1 <= yyssp)
    {
      /* Get the current used size of the three stacks, in elements.  */
      YYSIZE_T yysize = yyssp - yyss + 1;

#ifdef yyoverflow
      {
	/* Give user a chance to reallocate the stack.  Use copies of
	   these so that the &'s don't force the real ones into
	   memory.  */
	YYSTYPE *yyvs1 = yyvs;
	yytype_int16 *yyss1 = yyss;

	/* Each stack pointer address is followed by the size of the
	   data in use in that stack, in bytes.  This used to be a
	   conditional around just the two extra args, but that might
	   be undefined if yyoverflow is a macro.  */
	yyoverflow (YY_("memory exhausted"),
		    &yyss1, yysize * sizeof (*yyssp),
		    &yyvs1, yysize * sizeof (*yyvsp),
		    &yystacksize);

	yyss = yyss1;
	yyvs = yyvs1;
      }
#else /* no yyoverflow */
# ifndef YYSTACK_RELOCATE
      goto yyexhaustedlab;
# else
      /* Extend the stack our own way.  */
      if (YYMAXDEPTH <= yystacksize)
	goto yyexhaustedlab;
      yystacksize *= 2;
      if (YYMAXDEPTH < yystacksize)
	yystacksize = YYMAXDEPTH;

      {
	yytype_int16 *yyss1 = yyss;
	union yyalloc *yyptr =
	  (union yyalloc *) YYSTACK_ALLOC (YYSTACK_BYTES (yystacksize));
	if (! yyptr)
	  goto yyexhaustedlab;
	YYSTACK_RELOCATE (yyss_alloc, yyss);
	YYSTACK_RELOCATE (yyvs_alloc, yyvs);
#  undef YYSTACK_RELOCATE
	if (yyss1 != yyssa)
	  YYSTACK_FREE (yyss1);
      }
# endif
#endif /* no yyoverflow */

      yyssp = yyss + yysize - 1;
      yyvsp = yyvs + yysize - 1;

      YYDPRINTF ((stderr, "Stack size increased to %lu\n",
		  (unsigned long int) yystacksize));

      if (yyss + yystacksize - 1 <= yyssp)
	YYABORT;
    }

  YYDPRINTF ((stderr, "Entering state %d\n", yystate));

  if (yystate == YYFINAL)
    YYACCEPT;

  goto yybackup;

/*-----------.
| yybackup.  |
`-----------*/
yybackup:

  /* Do appropriate processing given the current state.  Read a
     lookahead token if we need one and don't already have one.  */

  /* First try to decide what to do without reference to lookahead token.  */
  yyn = yypact[yystate];
  if (yypact_value_is_default (yyn))
    goto yydefault;

  /* Not known => get a lookahead token if don't already have one.  */

  /* YYCHAR is either YYEMPTY or YYEOF or a valid lookahead symbol.  */
  if (yychar == YYEMPTY)
    {
      YYDPRINTF ((stderr, "Reading a token: "));
      yychar = YYLEX;
    }

  if (yychar <= YYEOF)
    {
      yychar = yytoken = YYEOF;
      YYDPRINTF ((stderr, "Now at end of input.\n"));
    }
  else
    {
      yytoken = YYTRANSLATE (yychar);
      YY_SYMBOL_PRINT ("Next token is", yytoken, &yylval, &yylloc);
    }

  /* If the proper action on seeing token YYTOKEN is to reduce or to
     detect an error, take that action.  */
  yyn += yytoken;
  if (yyn < 0 || YYLAST < yyn || yycheck[yyn] != yytoken)
    goto yydefault;
  yyn = yytable[yyn];
  if (yyn <= 0)
    {
      if (yytable_value_is_error (yyn))
        goto yyerrlab;
      yyn = -yyn;
      goto yyreduce;
    }

  /* Count tokens shifted since error; after three, turn off error
     status.  */
  if (yyerrstatus)
    yyerrstatus--;

  /* Shift the lookahead token.  */
  YY_SYMBOL_PRINT ("Shifting", yytoken, &yylval, &yylloc);

  /* Discard the shifted token.  */
  yychar = YYEMPTY;

  yystate = yyn;
  *++yyvsp = yylval;

  goto yynewstate;


/*-----------------------------------------------------------.
| yydefault -- do the default action for the current state.  |
`-----------------------------------------------------------*/
yydefault:
  yyn = yydefact[yystate];
  if (yyn == 0)
    goto yyerrlab;
  goto yyreduce;


/*-----------------------------.
| yyreduce -- Do a reduction.  |
`-----------------------------*/
yyreduce:
  /* yyn is the number of a rule to reduce with.  */
  yylen = yyr2[yyn];

  /* If YYLEN is nonzero, implement the default value of the action:
     `$$ = $1'.

     Otherwise, the following line sets YYVAL to garbage.
     This behavior is undocumented and Bison
     users should not rely upon it.  Assigning to YYVAL
     unconditionally makes the parser a bit smaller, and it avoids a
     GCC warning that YYVAL may be used uninitialized.  */
  yyval = yyvsp[1-yylen];


  YY_REDUCE_PRINT (yyn);
  switch (yyn)
    {
        case 4:

/* Line 1806 of yacc.c  */
#line 156 "policy_parse.y"
    { if (define_policy(pass, 0) == -1) return -1; }
    break;

  case 5:

/* Line 1806 of yacc.c  */
#line 158 "policy_parse.y"
    { if (pass == 1) { if (policydb_index_classes(policydbp)) return -1; }
                            else if (pass == 2) { if (policydb_index_others(NULL, policydbp, 0)) return -1; }}
    break;

  case 6:

/* Line 1806 of yacc.c  */
#line 161 "policy_parse.y"
    { if (pass == 1) { if (policydb_index_bools(policydbp)) return -1;}
			   else if (pass == 2) { if (policydb_index_others(NULL, policydbp, 0)) return -1;}}
    break;

  case 10:

/* Line 1806 of yacc.c  */
#line 169 "policy_parse.y"
    {if (define_class()) return -1;}
    break;

  case 13:

/* Line 1806 of yacc.c  */
#line 175 "policy_parse.y"
    {if (define_initial_sid()) return -1;}
    break;

  case 19:

/* Line 1806 of yacc.c  */
#line 186 "policy_parse.y"
    {if (define_common_perms()) return -1;}
    break;

  case 22:

/* Line 1806 of yacc.c  */
#line 192 "policy_parse.y"
    {if (define_av_perms(FALSE)) return -1;}
    break;

  case 23:

/* Line 1806 of yacc.c  */
#line 194 "policy_parse.y"
    {if (define_av_perms(TRUE)) return -1;}
    break;

  case 24:

/* Line 1806 of yacc.c  */
#line 196 "policy_parse.y"
    {if (define_av_perms(TRUE)) return -1;}
    break;

  case 30:

/* Line 1806 of yacc.c  */
#line 207 "policy_parse.y"
    {if (define_sens()) return -1;}
    break;

  case 31:

/* Line 1806 of yacc.c  */
#line 209 "policy_parse.y"
    {if (define_sens()) return -1;}
    break;

  case 33:

/* Line 1806 of yacc.c  */
#line 214 "policy_parse.y"
    {if (define_dominance()) return -1;}
    break;

  case 34:

/* Line 1806 of yacc.c  */
#line 216 "policy_parse.y"
    {if (define_dominance()) return -1;}
    break;

  case 39:

/* Line 1806 of yacc.c  */
#line 225 "policy_parse.y"
    {if (define_category()) return -1;}
    break;

  case 40:

/* Line 1806 of yacc.c  */
#line 227 "policy_parse.y"
    {if (define_category()) return -1;}
    break;

  case 43:

/* Line 1806 of yacc.c  */
#line 233 "policy_parse.y"
    {if (define_level()) return -1;}
    break;

  case 44:

/* Line 1806 of yacc.c  */
#line 235 "policy_parse.y"
    {if (define_level()) return -1;}
    break;

  case 49:

/* Line 1806 of yacc.c  */
#line 244 "policy_parse.y"
    { if (define_constraint((constraint_expr_t*)(yyvsp[(4) - (5)].valptr))) return -1; }
    break;

  case 50:

/* Line 1806 of yacc.c  */
#line 247 "policy_parse.y"
    { if (define_validatetrans((constraint_expr_t*)(yyvsp[(3) - (4)].valptr))) return -1; }
    break;

  case 77:

/* Line 1806 of yacc.c  */
#line 280 "policy_parse.y"
    { if (define_attrib()) return -1;}
    break;

  case 78:

/* Line 1806 of yacc.c  */
#line 283 "policy_parse.y"
    {if (define_type(1)) return -1;}
    break;

  case 79:

/* Line 1806 of yacc.c  */
#line 285 "policy_parse.y"
    {if (define_type(0)) return -1;}
    break;

  case 80:

/* Line 1806 of yacc.c  */
#line 288 "policy_parse.y"
    {if (define_typealias()) return -1;}
    break;

  case 81:

/* Line 1806 of yacc.c  */
#line 291 "policy_parse.y"
    {if (define_typeattribute()) return -1;}
    break;

  case 82:

/* Line 1806 of yacc.c  */
#line 294 "policy_parse.y"
    {if (define_typebounds()) return -1;}
    break;

  case 85:

/* Line 1806 of yacc.c  */
#line 300 "policy_parse.y"
    { if (define_bool_tunable(0)) return -1; }
    break;

  case 86:

/* Line 1806 of yacc.c  */
#line 303 "policy_parse.y"
    { if (define_bool_tunable(1)) return -1; }
    break;

  case 87:

/* Line 1806 of yacc.c  */
#line 306 "policy_parse.y"
    { if (insert_id("T",0)) return -1; }
    break;

  case 88:

/* Line 1806 of yacc.c  */
#line 308 "policy_parse.y"
    { if (insert_id("F",0)) return -1; }
    break;

  case 89:

/* Line 1806 of yacc.c  */
#line 311 "policy_parse.y"
    { if (pass == 2) { if (define_conditional((cond_expr_t*)(yyvsp[(2) - (6)].ptr), (avrule_t*)(yyvsp[(4) - (6)].ptr), (avrule_t*)(yyvsp[(6) - (6)].ptr)) < 0) return -1;  }}
    break;

  case 90:

/* Line 1806 of yacc.c  */
#line 314 "policy_parse.y"
    { (yyval.ptr) = (yyvsp[(3) - (4)].ptr); }
    break;

  case 91:

/* Line 1806 of yacc.c  */
#line 316 "policy_parse.y"
    { (yyval.ptr) = NULL; }
    break;

  case 92:

/* Line 1806 of yacc.c  */
#line 318 "policy_parse.y"
    { (yyval.ptr) = (yyvsp[(2) - (3)].ptr);}
    break;

  case 93:

/* Line 1806 of yacc.c  */
#line 320 "policy_parse.y"
    { (yyval.ptr) = define_cond_expr(COND_NOT, (yyvsp[(2) - (2)].ptr), 0);
			  if ((yyval.ptr) == 0) return -1; }
    break;

  case 94:

/* Line 1806 of yacc.c  */
#line 323 "policy_parse.y"
    { (yyval.ptr) = define_cond_expr(COND_AND, (yyvsp[(1) - (3)].ptr), (yyvsp[(3) - (3)].ptr));
			  if ((yyval.ptr) == 0) return  -1; }
    break;

  case 95:

/* Line 1806 of yacc.c  */
#line 326 "policy_parse.y"
    { (yyval.ptr) = define_cond_expr(COND_OR, (yyvsp[(1) - (3)].ptr), (yyvsp[(3) - (3)].ptr));
			  if ((yyval.ptr) == 0) return   -1; }
    break;

  case 96:

/* Line 1806 of yacc.c  */
#line 329 "policy_parse.y"
    { (yyval.ptr) = define_cond_expr(COND_XOR, (yyvsp[(1) - (3)].ptr), (yyvsp[(3) - (3)].ptr));
			  if ((yyval.ptr) == 0) return  -1; }
    break;

  case 97:

/* Line 1806 of yacc.c  */
#line 332 "policy_parse.y"
    { (yyval.ptr) = define_cond_expr(COND_EQ, (yyvsp[(1) - (3)].ptr), (yyvsp[(3) - (3)].ptr));
			  if ((yyval.ptr) == 0) return  -1; }
    break;

  case 98:

/* Line 1806 of yacc.c  */
#line 335 "policy_parse.y"
    { (yyval.ptr) = define_cond_expr(COND_NEQ, (yyvsp[(1) - (3)].ptr), (yyvsp[(3) - (3)].ptr));
			  if ((yyval.ptr) == 0) return  -1; }
    break;

  case 99:

/* Line 1806 of yacc.c  */
#line 338 "policy_parse.y"
    { (yyval.ptr) = (yyvsp[(1) - (1)].ptr); }
    break;

  case 100:

/* Line 1806 of yacc.c  */
#line 341 "policy_parse.y"
    { (yyval.ptr) = define_cond_expr(COND_BOOL,0, 0);
			  if ((yyval.ptr) == COND_ERR) return   -1; }
    break;

  case 101:

/* Line 1806 of yacc.c  */
#line 345 "policy_parse.y"
    { (yyval.ptr) = define_cond_pol_list((avrule_t *)(yyvsp[(1) - (2)].ptr), (avrule_t *)(yyvsp[(2) - (2)].ptr)); }
    break;

  case 102:

/* Line 1806 of yacc.c  */
#line 347 "policy_parse.y"
    { (yyval.ptr) = NULL; }
    break;

  case 103:

/* Line 1806 of yacc.c  */
#line 350 "policy_parse.y"
    { (yyval.ptr) = (yyvsp[(1) - (1)].ptr); }
    break;

  case 104:

/* Line 1806 of yacc.c  */
#line 352 "policy_parse.y"
    { (yyval.ptr) = (yyvsp[(1) - (1)].ptr); }
    break;

  case 105:

/* Line 1806 of yacc.c  */
#line 354 "policy_parse.y"
    { (yyval.ptr) = NULL; }
    break;

  case 106:

/* Line 1806 of yacc.c  */
#line 357 "policy_parse.y"
    { (yyval.ptr) = define_cond_filename_trans() ;
                          if ((yyval.ptr) == COND_ERR) return -1;}
    break;

  case 107:

/* Line 1806 of yacc.c  */
#line 360 "policy_parse.y"
    { (yyval.ptr) = define_cond_compute_type(AVRULE_TRANSITION) ;
                          if ((yyval.ptr) == COND_ERR) return -1;}
    break;

  case 108:

/* Line 1806 of yacc.c  */
#line 363 "policy_parse.y"
    { (yyval.ptr) = define_cond_compute_type(AVRULE_MEMBER) ;
                          if ((yyval.ptr) ==  COND_ERR) return -1;}
    break;

  case 109:

/* Line 1806 of yacc.c  */
#line 366 "policy_parse.y"
    { (yyval.ptr) = define_cond_compute_type(AVRULE_CHANGE) ;
                          if ((yyval.ptr) == COND_ERR) return -1;}
    break;

  case 110:

/* Line 1806 of yacc.c  */
#line 370 "policy_parse.y"
    { (yyval.ptr) = (yyvsp[(1) - (1)].ptr); }
    break;

  case 111:

/* Line 1806 of yacc.c  */
#line 372 "policy_parse.y"
    { (yyval.ptr) = (yyvsp[(1) - (1)].ptr); }
    break;

  case 112:

/* Line 1806 of yacc.c  */
#line 374 "policy_parse.y"
    { (yyval.ptr) = (yyvsp[(1) - (1)].ptr); }
    break;

  case 113:

/* Line 1806 of yacc.c  */
#line 376 "policy_parse.y"
    { (yyval.ptr) = (yyvsp[(1) - (1)].ptr); }
    break;

  case 114:

/* Line 1806 of yacc.c  */
#line 379 "policy_parse.y"
    { (yyval.ptr) = define_cond_te_avtab(AVRULE_ALLOWED) ;
                          if ((yyval.ptr) == COND_ERR) return -1; }
    break;

  case 115:

/* Line 1806 of yacc.c  */
#line 383 "policy_parse.y"
    { (yyval.ptr) = define_cond_te_avtab(AVRULE_AUDITALLOW) ;
                          if ((yyval.ptr) == COND_ERR) return -1; }
    break;

  case 116:

/* Line 1806 of yacc.c  */
#line 387 "policy_parse.y"
    { (yyval.ptr) = define_cond_te_avtab(AVRULE_AUDITDENY) ;
                          if ((yyval.ptr) == COND_ERR) return -1; }
    break;

  case 117:

/* Line 1806 of yacc.c  */
#line 391 "policy_parse.y"
    { (yyval.ptr) = define_cond_te_avtab(AVRULE_DONTAUDIT);
                          if ((yyval.ptr) == COND_ERR) return -1; }
    break;

  case 118:

/* Line 1806 of yacc.c  */
#line 396 "policy_parse.y"
    {if (define_filename_trans()) return -1; }
    break;

  case 119:

/* Line 1806 of yacc.c  */
#line 398 "policy_parse.y"
    {if (define_compute_type(AVRULE_TRANSITION)) return -1;}
    break;

  case 120:

/* Line 1806 of yacc.c  */
#line 400 "policy_parse.y"
    {if (define_compute_type(AVRULE_MEMBER)) return -1;}
    break;

  case 121:

/* Line 1806 of yacc.c  */
#line 402 "policy_parse.y"
    {if (define_compute_type(AVRULE_CHANGE)) return -1;}
    break;

  case 122:

/* Line 1806 of yacc.c  */
#line 405 "policy_parse.y"
    { if (define_range_trans(0)) return -1; }
    break;

  case 123:

/* Line 1806 of yacc.c  */
#line 407 "policy_parse.y"
    { if (define_range_trans(1)) return -1; }
    break;

  case 129:

/* Line 1806 of yacc.c  */
#line 416 "policy_parse.y"
    {if (define_te_avtab(AVRULE_ALLOWED)) return -1; }
    break;

  case 130:

/* Line 1806 of yacc.c  */
#line 419 "policy_parse.y"
    {if (define_te_avtab(AVRULE_AUDITALLOW)) return -1; }
    break;

  case 131:

/* Line 1806 of yacc.c  */
#line 422 "policy_parse.y"
    {if (define_te_avtab(AVRULE_AUDITDENY)) return -1; }
    break;

  case 132:

/* Line 1806 of yacc.c  */
#line 425 "policy_parse.y"
    {if (define_te_avtab(AVRULE_DONTAUDIT)) return -1; }
    break;

  case 133:

/* Line 1806 of yacc.c  */
#line 428 "policy_parse.y"
    {if (define_te_avtab(AVRULE_NEVERALLOW)) return -1; }
    break;

  case 134:

/* Line 1806 of yacc.c  */
#line 431 "policy_parse.y"
    {if (define_attrib_role()) return -1; }
    break;

  case 135:

/* Line 1806 of yacc.c  */
#line 434 "policy_parse.y"
    {if (define_role_types()) return -1;}
    break;

  case 136:

/* Line 1806 of yacc.c  */
#line 437 "policy_parse.y"
    {if (define_role_attr()) return -1;}
    break;

  case 138:

/* Line 1806 of yacc.c  */
#line 442 "policy_parse.y"
    {if (define_role_trans(0)) return -1; }
    break;

  case 139:

/* Line 1806 of yacc.c  */
#line 444 "policy_parse.y"
    {if (define_role_trans(1)) return -1;}
    break;

  case 140:

/* Line 1806 of yacc.c  */
#line 447 "policy_parse.y"
    {if (define_role_allow()) return -1; }
    break;

  case 141:

/* Line 1806 of yacc.c  */
#line 450 "policy_parse.y"
    { (yyval.ptr) = (yyvsp[(1) - (1)].ptr); }
    break;

  case 142:

/* Line 1806 of yacc.c  */
#line 452 "policy_parse.y"
    { (yyval.ptr) = merge_roles_dom((role_datum_t*)(yyvsp[(1) - (2)].ptr), (role_datum_t*)(yyvsp[(2) - (2)].ptr)); if ((yyval.ptr) == 0) return -1;}
    break;

  case 143:

/* Line 1806 of yacc.c  */
#line 455 "policy_parse.y"
    {(yyval.ptr) = define_role_dom(NULL); if ((yyval.ptr) == 0) return -1;}
    break;

  case 144:

/* Line 1806 of yacc.c  */
#line 457 "policy_parse.y"
    {(yyval.ptr) = define_role_dom((role_datum_t*)(yyvsp[(4) - (5)].ptr)); if ((yyval.ptr) == 0) return -1;}
    break;

  case 145:

/* Line 1806 of yacc.c  */
#line 460 "policy_parse.y"
    {if (define_roleattribute()) return -1;}
    break;

  case 152:

/* Line 1806 of yacc.c  */
#line 472 "policy_parse.y"
    { if (define_constraint((constraint_expr_t*)(yyvsp[(4) - (5)].valptr))) return -1; }
    break;

  case 153:

/* Line 1806 of yacc.c  */
#line 475 "policy_parse.y"
    { if (define_validatetrans((constraint_expr_t*)(yyvsp[(3) - (4)].valptr))) return -1; }
    break;

  case 154:

/* Line 1806 of yacc.c  */
#line 478 "policy_parse.y"
    { (yyval.valptr) = (yyvsp[(2) - (3)].valptr); }
    break;

  case 155:

/* Line 1806 of yacc.c  */
#line 480 "policy_parse.y"
    { (yyval.valptr) = define_cexpr(CEXPR_NOT, (yyvsp[(2) - (2)].valptr), 0);
			  if ((yyval.valptr) == 0) return -1; }
    break;

  case 156:

/* Line 1806 of yacc.c  */
#line 483 "policy_parse.y"
    { (yyval.valptr) = define_cexpr(CEXPR_AND, (yyvsp[(1) - (3)].valptr), (yyvsp[(3) - (3)].valptr));
			  if ((yyval.valptr) == 0) return -1; }
    break;

  case 157:

/* Line 1806 of yacc.c  */
#line 486 "policy_parse.y"
    { (yyval.valptr) = define_cexpr(CEXPR_OR, (yyvsp[(1) - (3)].valptr), (yyvsp[(3) - (3)].valptr));
			  if ((yyval.valptr) == 0) return -1; }
    break;

  case 158:

/* Line 1806 of yacc.c  */
#line 489 "policy_parse.y"
    { (yyval.valptr) = (yyvsp[(1) - (1)].valptr); }
    break;

  case 159:

/* Line 1806 of yacc.c  */
#line 492 "policy_parse.y"
    { (yyval.valptr) = define_cexpr(CEXPR_ATTR, CEXPR_USER, (yyvsp[(2) - (3)].valptr));
			  if ((yyval.valptr) == 0) return -1; }
    break;

  case 160:

/* Line 1806 of yacc.c  */
#line 495 "policy_parse.y"
    { (yyval.valptr) = define_cexpr(CEXPR_ATTR, CEXPR_ROLE, (yyvsp[(2) - (3)].valptr));
			  if ((yyval.valptr) == 0) return -1; }
    break;

  case 161:

/* Line 1806 of yacc.c  */
#line 498 "policy_parse.y"
    { (yyval.valptr) = define_cexpr(CEXPR_ATTR, CEXPR_TYPE, (yyvsp[(2) - (3)].valptr));
			  if ((yyval.valptr) == 0) return -1; }
    break;

  case 162:

/* Line 1806 of yacc.c  */
#line 500 "policy_parse.y"
    { if (insert_separator(1)) return -1; }
    break;

  case 163:

/* Line 1806 of yacc.c  */
#line 501 "policy_parse.y"
    { (yyval.valptr) = define_cexpr(CEXPR_NAMES, CEXPR_USER, (yyvsp[(2) - (4)].valptr));
			  if ((yyval.valptr) == 0) return -1; }
    break;

  case 164:

/* Line 1806 of yacc.c  */
#line 503 "policy_parse.y"
    { if (insert_separator(1)) return -1; }
    break;

  case 165:

/* Line 1806 of yacc.c  */
#line 504 "policy_parse.y"
    { (yyval.valptr) = define_cexpr(CEXPR_NAMES, (CEXPR_USER | CEXPR_TARGET), (yyvsp[(2) - (4)].valptr));
			  if ((yyval.valptr) == 0) return -1; }
    break;

  case 166:

/* Line 1806 of yacc.c  */
#line 506 "policy_parse.y"
    { if (insert_separator(1)) return -1; }
    break;

  case 167:

/* Line 1806 of yacc.c  */
#line 507 "policy_parse.y"
    { (yyval.valptr) = define_cexpr(CEXPR_NAMES, (CEXPR_USER | CEXPR_XTARGET), (yyvsp[(2) - (4)].valptr));
			  if ((yyval.valptr) == 0) return -1; }
    break;

  case 168:

/* Line 1806 of yacc.c  */
#line 509 "policy_parse.y"
    { if (insert_separator(1)) return -1; }
    break;

  case 169:

/* Line 1806 of yacc.c  */
#line 510 "policy_parse.y"
    { (yyval.valptr) = define_cexpr(CEXPR_NAMES, CEXPR_ROLE, (yyvsp[(2) - (4)].valptr));
			  if ((yyval.valptr) == 0) return -1; }
    break;

  case 170:

/* Line 1806 of yacc.c  */
#line 512 "policy_parse.y"
    { if (insert_separator(1)) return -1; }
    break;

  case 171:

/* Line 1806 of yacc.c  */
#line 513 "policy_parse.y"
    { (yyval.valptr) = define_cexpr(CEXPR_NAMES, (CEXPR_ROLE | CEXPR_TARGET), (yyvsp[(2) - (4)].valptr));
			  if ((yyval.valptr) == 0) return -1; }
    break;

  case 172:

/* Line 1806 of yacc.c  */
#line 515 "policy_parse.y"
    { if (insert_separator(1)) return -1; }
    break;

  case 173:

/* Line 1806 of yacc.c  */
#line 516 "policy_parse.y"
    { (yyval.valptr) = define_cexpr(CEXPR_NAMES, (CEXPR_ROLE | CEXPR_XTARGET), (yyvsp[(2) - (4)].valptr));
			  if ((yyval.valptr) == 0) return -1; }
    break;

  case 174:

/* Line 1806 of yacc.c  */
#line 518 "policy_parse.y"
    { if (insert_separator(1)) return -1; }
    break;

  case 175:

/* Line 1806 of yacc.c  */
#line 519 "policy_parse.y"
    { (yyval.valptr) = define_cexpr(CEXPR_NAMES, CEXPR_TYPE, (yyvsp[(2) - (4)].valptr));
			  if ((yyval.valptr) == 0) return -1; }
    break;

  case 176:

/* Line 1806 of yacc.c  */
#line 521 "policy_parse.y"
    { if (insert_separator(1)) return -1; }
    break;

  case 177:

/* Line 1806 of yacc.c  */
#line 522 "policy_parse.y"
    { (yyval.valptr) = define_cexpr(CEXPR_NAMES, (CEXPR_TYPE | CEXPR_TARGET), (yyvsp[(2) - (4)].valptr));
			  if ((yyval.valptr) == 0) return -1; }
    break;

  case 178:

/* Line 1806 of yacc.c  */
#line 524 "policy_parse.y"
    { if (insert_separator(1)) return -1; }
    break;

  case 179:

/* Line 1806 of yacc.c  */
#line 525 "policy_parse.y"
    { (yyval.valptr) = define_cexpr(CEXPR_NAMES, (CEXPR_TYPE | CEXPR_XTARGET), (yyvsp[(2) - (4)].valptr));
			  if ((yyval.valptr) == 0) return -1; }
    break;

  case 180:

/* Line 1806 of yacc.c  */
#line 528 "policy_parse.y"
    { (yyval.valptr) = define_cexpr(CEXPR_ATTR, CEXPR_USER, CEXPR_EQ);
			  if ((yyval.valptr) == 0) return -1; }
    break;

  case 181:

/* Line 1806 of yacc.c  */
#line 530 "policy_parse.y"
    { if (insert_separator(1)) return -1; }
    break;

  case 182:

/* Line 1806 of yacc.c  */
#line 531 "policy_parse.y"
    { (yyval.valptr) = define_cexpr(CEXPR_NAMES, CEXPR_ROLE, CEXPR_EQ);
			  if ((yyval.valptr) == 0) return -1; }
    break;

  case 183:

/* Line 1806 of yacc.c  */
#line 533 "policy_parse.y"
    { if (insert_separator(1)) return -1; }
    break;

  case 184:

/* Line 1806 of yacc.c  */
#line 534 "policy_parse.y"
    { (yyval.valptr) = define_cexpr(CEXPR_NAMES, (CEXPR_ROLE | CEXPR_TARGET), CEXPR_EQ);
			  if ((yyval.valptr) == 0) return -1; }
    break;

  case 185:

/* Line 1806 of yacc.c  */
#line 537 "policy_parse.y"
    { (yyval.valptr) = define_cexpr(CEXPR_ATTR, CEXPR_ROLE, (yyvsp[(2) - (2)].valptr));
			  if ((yyval.valptr) == 0) return -1; }
    break;

  case 186:

/* Line 1806 of yacc.c  */
#line 539 "policy_parse.y"
    { if (insert_separator(1)) return -1; }
    break;

  case 187:

/* Line 1806 of yacc.c  */
#line 540 "policy_parse.y"
    { (yyval.valptr) = define_cexpr(CEXPR_NAMES, CEXPR_TYPE, CEXPR_EQ);
			  if ((yyval.valptr) == 0) return -1; }
    break;

  case 188:

/* Line 1806 of yacc.c  */
#line 542 "policy_parse.y"
    { if (insert_separator(1)) return -1; }
    break;

  case 189:

/* Line 1806 of yacc.c  */
#line 543 "policy_parse.y"
    { (yyval.valptr) = define_cexpr(CEXPR_NAMES, (CEXPR_TYPE | CEXPR_TARGET), CEXPR_EQ);
			  if ((yyval.valptr) == 0) return -1; }
    break;

  case 190:

/* Line 1806 of yacc.c  */
#line 546 "policy_parse.y"
    { (yyval.valptr) = define_cexpr(CEXPR_ATTR, CEXPR_L1L2, (yyvsp[(2) - (3)].valptr));
			  if ((yyval.valptr) == 0) return -1; }
    break;

  case 191:

/* Line 1806 of yacc.c  */
#line 549 "policy_parse.y"
    { (yyval.valptr) = define_cexpr(CEXPR_ATTR, CEXPR_L1H2, (yyvsp[(2) - (3)].valptr));
			  if ((yyval.valptr) == 0) return -1; }
    break;

  case 192:

/* Line 1806 of yacc.c  */
#line 552 "policy_parse.y"
    { (yyval.valptr) = define_cexpr(CEXPR_ATTR, CEXPR_H1L2, (yyvsp[(2) - (3)].valptr));
			  if ((yyval.valptr) == 0) return -1; }
    break;

  case 193:

/* Line 1806 of yacc.c  */
#line 555 "policy_parse.y"
    { (yyval.valptr) = define_cexpr(CEXPR_ATTR, CEXPR_H1H2, (yyvsp[(2) - (3)].valptr));
			  if ((yyval.valptr) == 0) return -1; }
    break;

  case 194:

/* Line 1806 of yacc.c  */
#line 558 "policy_parse.y"
    { (yyval.valptr) = define_cexpr(CEXPR_ATTR, CEXPR_L1H1, (yyvsp[(2) - (3)].valptr));
			  if ((yyval.valptr) == 0) return -1; }
    break;

  case 195:

/* Line 1806 of yacc.c  */
#line 561 "policy_parse.y"
    { (yyval.valptr) = define_cexpr(CEXPR_ATTR, CEXPR_L2H2, (yyvsp[(2) - (3)].valptr));
			  if ((yyval.valptr) == 0) return -1; }
    break;

  case 196:

/* Line 1806 of yacc.c  */
#line 565 "policy_parse.y"
    { (yyval.valptr) = CEXPR_EQ; }
    break;

  case 197:

/* Line 1806 of yacc.c  */
#line 567 "policy_parse.y"
    { (yyval.valptr) = CEXPR_NEQ; }
    break;

  case 198:

/* Line 1806 of yacc.c  */
#line 570 "policy_parse.y"
    { (yyval.valptr) = (yyvsp[(1) - (1)].valptr); }
    break;

  case 199:

/* Line 1806 of yacc.c  */
#line 572 "policy_parse.y"
    { (yyval.valptr) = CEXPR_DOM; }
    break;

  case 200:

/* Line 1806 of yacc.c  */
#line 574 "policy_parse.y"
    { (yyval.valptr) = CEXPR_DOMBY; }
    break;

  case 201:

/* Line 1806 of yacc.c  */
#line 576 "policy_parse.y"
    { (yyval.valptr) = CEXPR_INCOMP; }
    break;

  case 204:

/* Line 1806 of yacc.c  */
#line 582 "policy_parse.y"
    {if (define_user()) return -1;}
    break;

  case 209:

/* Line 1806 of yacc.c  */
#line 591 "policy_parse.y"
    {if (define_initial_sid_context()) return -1;}
    break;

  case 218:

/* Line 1806 of yacc.c  */
#line 604 "policy_parse.y"
    {if (define_pirq_context((yyvsp[(2) - (3)].val))) return -1;}
    break;

  case 219:

/* Line 1806 of yacc.c  */
#line 607 "policy_parse.y"
    {if (define_iomem_context((yyvsp[(2) - (3)].val),(yyvsp[(2) - (3)].val))) return -1;}
    break;

  case 220:

/* Line 1806 of yacc.c  */
#line 609 "policy_parse.y"
    {if (define_iomem_context((yyvsp[(2) - (5)].val),(yyvsp[(4) - (5)].val))) return -1;}
    break;

  case 221:

/* Line 1806 of yacc.c  */
#line 612 "policy_parse.y"
    {if (define_ioport_context((yyvsp[(2) - (3)].val),(yyvsp[(2) - (3)].val))) return -1;}
    break;

  case 222:

/* Line 1806 of yacc.c  */
#line 614 "policy_parse.y"
    {if (define_ioport_context((yyvsp[(2) - (5)].val),(yyvsp[(4) - (5)].val))) return -1;}
    break;

  case 223:

/* Line 1806 of yacc.c  */
#line 617 "policy_parse.y"
    {if (define_pcidevice_context((yyvsp[(2) - (3)].val))) return -1;}
    break;

  case 228:

/* Line 1806 of yacc.c  */
#line 626 "policy_parse.y"
    {if (define_fs_context((yyvsp[(2) - (5)].val),(yyvsp[(3) - (5)].val))) return -1;}
    break;

  case 234:

/* Line 1806 of yacc.c  */
#line 637 "policy_parse.y"
    {if (define_port_context((yyvsp[(3) - (4)].val),(yyvsp[(3) - (4)].val))) return -1;}
    break;

  case 235:

/* Line 1806 of yacc.c  */
#line 639 "policy_parse.y"
    {if (define_port_context((yyvsp[(3) - (6)].val),(yyvsp[(5) - (6)].val))) return -1;}
    break;

  case 240:

/* Line 1806 of yacc.c  */
#line 648 "policy_parse.y"
    {if (define_netif_context()) return -1;}
    break;

  case 245:

/* Line 1806 of yacc.c  */
#line 657 "policy_parse.y"
    {if (define_ipv4_node_context()) return -1;}
    break;

  case 246:

/* Line 1806 of yacc.c  */
#line 659 "policy_parse.y"
    {if (define_ipv6_node_context()) return -1;}
    break;

  case 251:

/* Line 1806 of yacc.c  */
#line 668 "policy_parse.y"
    {if (define_fs_use(SECURITY_FS_USE_XATTR)) return -1;}
    break;

  case 252:

/* Line 1806 of yacc.c  */
#line 670 "policy_parse.y"
    {if (define_fs_use(SECURITY_FS_USE_TASK)) return -1;}
    break;

  case 253:

/* Line 1806 of yacc.c  */
#line 672 "policy_parse.y"
    {if (define_fs_use(SECURITY_FS_USE_TRANS)) return -1;}
    break;

  case 258:

/* Line 1806 of yacc.c  */
#line 681 "policy_parse.y"
    {if (define_genfs_context(1)) return -1;}
    break;

  case 259:

/* Line 1806 of yacc.c  */
#line 682 "policy_parse.y"
    {insert_id("-", 0);}
    break;

  case 260:

/* Line 1806 of yacc.c  */
#line 683 "policy_parse.y"
    {if (define_genfs_context(1)) return -1;}
    break;

  case 261:

/* Line 1806 of yacc.c  */
#line 685 "policy_parse.y"
    {if (define_genfs_context(0)) return -1;}
    break;

  case 262:

/* Line 1806 of yacc.c  */
#line 688 "policy_parse.y"
    { if (insert_id(yytext,0)) return -1; }
    break;

  case 266:

/* Line 1806 of yacc.c  */
#line 696 "policy_parse.y"
    {if (insert_separator(0)) return -1;}
    break;

  case 267:

/* Line 1806 of yacc.c  */
#line 698 "policy_parse.y"
    {if (insert_separator(0)) return -1;}
    break;

  case 268:

/* Line 1806 of yacc.c  */
#line 701 "policy_parse.y"
    {if (insert_separator(0)) return -1;}
    break;

  case 269:

/* Line 1806 of yacc.c  */
#line 703 "policy_parse.y"
    {if (insert_separator(0)) return -1;}
    break;

  case 274:

/* Line 1806 of yacc.c  */
#line 713 "policy_parse.y"
    { if (insert_separator(0)) return -1; }
    break;

  case 275:

/* Line 1806 of yacc.c  */
#line 715 "policy_parse.y"
    { if (insert_separator(0)) return -1; }
    break;

  case 276:

/* Line 1806 of yacc.c  */
#line 717 "policy_parse.y"
    { if (insert_id("*", 0)) return -1; 
			  if (insert_separator(0)) return -1; }
    break;

  case 277:

/* Line 1806 of yacc.c  */
#line 720 "policy_parse.y"
    { if (insert_id("~", 0)) return -1;
			  if (insert_separator(0)) return -1; }
    break;

  case 278:

/* Line 1806 of yacc.c  */
#line 723 "policy_parse.y"
    { if (insert_id("~", 0)) return -1; 
			  if (insert_separator(0)) return -1; }
    break;

  case 279:

/* Line 1806 of yacc.c  */
#line 725 "policy_parse.y"
    { if (insert_id("-", 0)) return -1; }
    break;

  case 280:

/* Line 1806 of yacc.c  */
#line 726 "policy_parse.y"
    { if (insert_separator(0)) return -1; }
    break;

  case 281:

/* Line 1806 of yacc.c  */
#line 729 "policy_parse.y"
    { if (insert_id("~", 1)) return -1; }
    break;

  case 282:

/* Line 1806 of yacc.c  */
#line 732 "policy_parse.y"
    { if (insert_id("*", 1)) return -1; }
    break;

  case 290:

/* Line 1806 of yacc.c  */
#line 744 "policy_parse.y"
    { if (insert_id(yytext, 1)) return -1; }
    break;

  case 297:

/* Line 1806 of yacc.c  */
#line 753 "policy_parse.y"
    { if (insert_id("-", 0)) return -1; }
    break;

  case 300:

/* Line 1806 of yacc.c  */
#line 756 "policy_parse.y"
    { if (insert_id(yytext,0)) return -1; }
    break;

  case 301:

/* Line 1806 of yacc.c  */
#line 759 "policy_parse.y"
    { if (insert_id(yytext,0)) return -1; }
    break;

  case 302:

/* Line 1806 of yacc.c  */
#line 761 "policy_parse.y"
    { if (insert_id(yytext,0)) return -1; }
    break;

  case 303:

/* Line 1806 of yacc.c  */
#line 764 "policy_parse.y"
    { if (insert_id(yytext,0)) return -1; }
    break;

  case 304:

/* Line 1806 of yacc.c  */
#line 767 "policy_parse.y"
    { yytext[strlen(yytext) - 1] = '\0'; if (insert_id(yytext + 1,0)) return -1; }
    break;

  case 305:

/* Line 1806 of yacc.c  */
#line 770 "policy_parse.y"
    { (yyval.val) = strtoul(yytext,NULL,0); }
    break;

  case 306:

/* Line 1806 of yacc.c  */
#line 773 "policy_parse.y"
    { if (insert_id(yytext,0)) return -1; }
    break;

  case 307:

/* Line 1806 of yacc.c  */
#line 776 "policy_parse.y"
    {if (define_polcap()) return -1;}
    break;

  case 308:

/* Line 1806 of yacc.c  */
#line 779 "policy_parse.y"
    {if (define_permissive()) return -1;}
    break;

  case 309:

/* Line 1806 of yacc.c  */
#line 784 "policy_parse.y"
    { if (end_avrule_block(pass) == -1) return -1;
                          if (policydb_index_others(NULL, policydbp, 0)) return -1;
                        }
    break;

  case 310:

/* Line 1806 of yacc.c  */
#line 789 "policy_parse.y"
    { if (define_policy(pass, 1) == -1) return -1; }
    break;

  case 311:

/* Line 1806 of yacc.c  */
#line 792 "policy_parse.y"
    { if (insert_id(yytext,0)) return -1; }
    break;

  case 312:

/* Line 1806 of yacc.c  */
#line 794 "policy_parse.y"
    { if (insert_id(yytext,0)) return -1; }
    break;

  case 328:

/* Line 1806 of yacc.c  */
#line 818 "policy_parse.y"
    { if (require_class(pass)) return -1; }
    break;

  case 329:

/* Line 1806 of yacc.c  */
#line 820 "policy_parse.y"
    { (yyval.require_func) = require_role; }
    break;

  case 330:

/* Line 1806 of yacc.c  */
#line 821 "policy_parse.y"
    { (yyval.require_func) = require_type; }
    break;

  case 331:

/* Line 1806 of yacc.c  */
#line 822 "policy_parse.y"
    { (yyval.require_func) = require_attribute; }
    break;

  case 332:

/* Line 1806 of yacc.c  */
#line 823 "policy_parse.y"
    { (yyval.require_func) = require_attribute_role; }
    break;

  case 333:

/* Line 1806 of yacc.c  */
#line 824 "policy_parse.y"
    { (yyval.require_func) = require_user; }
    break;

  case 334:

/* Line 1806 of yacc.c  */
#line 825 "policy_parse.y"
    { (yyval.require_func) = require_bool; }
    break;

  case 335:

/* Line 1806 of yacc.c  */
#line 826 "policy_parse.y"
    { (yyval.require_func) = require_tunable; }
    break;

  case 336:

/* Line 1806 of yacc.c  */
#line 827 "policy_parse.y"
    { (yyval.require_func) = require_sens; }
    break;

  case 337:

/* Line 1806 of yacc.c  */
#line 828 "policy_parse.y"
    { (yyval.require_func) = require_cat; }
    break;

  case 338:

/* Line 1806 of yacc.c  */
#line 831 "policy_parse.y"
    { if ((yyvsp[(0) - (1)].require_func) (pass)) return -1; }
    break;

  case 339:

/* Line 1806 of yacc.c  */
#line 833 "policy_parse.y"
    { if ((yyvsp[(0) - (3)].require_func) (pass)) return -1; }
    break;

  case 340:

/* Line 1806 of yacc.c  */
#line 836 "policy_parse.y"
    { if (end_avrule_block(pass) == -1) return -1; }
    break;

  case 341:

/* Line 1806 of yacc.c  */
#line 838 "policy_parse.y"
    { if (end_optional(pass) == -1) return -1; }
    break;

  case 342:

/* Line 1806 of yacc.c  */
#line 841 "policy_parse.y"
    { if (end_avrule_block(pass) == -1) return -1; }
    break;

  case 344:

/* Line 1806 of yacc.c  */
#line 845 "policy_parse.y"
    { if (begin_optional(pass) == -1) return -1; }
    break;

  case 345:

/* Line 1806 of yacc.c  */
#line 848 "policy_parse.y"
    { if (begin_optional_else(pass) == -1) return -1; }
    break;



/* Line 1806 of yacc.c  */
#line 3737 "y.tab.c"
      default: break;
    }
  /* User semantic actions sometimes alter yychar, and that requires
     that yytoken be updated with the new translation.  We take the
     approach of translating immediately before every use of yytoken.
     One alternative is translating here after every semantic action,
     but that translation would be missed if the semantic action invokes
     YYABORT, YYACCEPT, or YYERROR immediately after altering yychar or
     if it invokes YYBACKUP.  In the case of YYABORT or YYACCEPT, an
     incorrect destructor might then be invoked immediately.  In the
     case of YYERROR or YYBACKUP, subsequent parser actions might lead
     to an incorrect destructor call or verbose syntax error message
     before the lookahead is translated.  */
  YY_SYMBOL_PRINT ("-> $$ =", yyr1[yyn], &yyval, &yyloc);

  YYPOPSTACK (yylen);
  yylen = 0;
  YY_STACK_PRINT (yyss, yyssp);

  *++yyvsp = yyval;

  /* Now `shift' the result of the reduction.  Determine what state
     that goes to, based on the state we popped back to and the rule
     number reduced by.  */

  yyn = yyr1[yyn];

  yystate = yypgoto[yyn - YYNTOKENS] + *yyssp;
  if (0 <= yystate && yystate <= YYLAST && yycheck[yystate] == *yyssp)
    yystate = yytable[yystate];
  else
    yystate = yydefgoto[yyn - YYNTOKENS];

  goto yynewstate;


/*------------------------------------.
| yyerrlab -- here on detecting error |
`------------------------------------*/
yyerrlab:
  /* Make sure we have latest lookahead translation.  See comments at
     user semantic actions for why this is necessary.  */
  yytoken = yychar == YYEMPTY ? YYEMPTY : YYTRANSLATE (yychar);

  /* If not already recovering from an error, report this error.  */
  if (!yyerrstatus)
    {
      ++yynerrs;
#if ! YYERROR_VERBOSE
      yyerror (YY_("syntax error"));
#else
# define YYSYNTAX_ERROR yysyntax_error (&yymsg_alloc, &yymsg, \
                                        yyssp, yytoken)
      {
        char const *yymsgp = YY_("syntax error");
        int yysyntax_error_status;
        yysyntax_error_status = YYSYNTAX_ERROR;
        if (yysyntax_error_status == 0)
          yymsgp = yymsg;
        else if (yysyntax_error_status == 1)
          {
            if (yymsg != yymsgbuf)
              YYSTACK_FREE (yymsg);
            yymsg = (char *) YYSTACK_ALLOC (yymsg_alloc);
            if (!yymsg)
              {
                yymsg = yymsgbuf;
                yymsg_alloc = sizeof yymsgbuf;
                yysyntax_error_status = 2;
              }
            else
              {
                yysyntax_error_status = YYSYNTAX_ERROR;
                yymsgp = yymsg;
              }
          }
        yyerror (yymsgp);
        if (yysyntax_error_status == 2)
          goto yyexhaustedlab;
      }
# undef YYSYNTAX_ERROR
#endif
    }



  if (yyerrstatus == 3)
    {
      /* If just tried and failed to reuse lookahead token after an
	 error, discard it.  */

      if (yychar <= YYEOF)
	{
	  /* Return failure if at end of input.  */
	  if (yychar == YYEOF)
	    YYABORT;
	}
      else
	{
	  yydestruct ("Error: discarding",
		      yytoken, &yylval);
	  yychar = YYEMPTY;
	}
    }

  /* Else will try to reuse lookahead token after shifting the error
     token.  */
  goto yyerrlab1;


/*---------------------------------------------------.
| yyerrorlab -- error raised explicitly by YYERROR.  |
`---------------------------------------------------*/
yyerrorlab:

  /* Pacify compilers like GCC when the user code never invokes
     YYERROR and the label yyerrorlab therefore never appears in user
     code.  */
  if (/*CONSTCOND*/ 0)
     goto yyerrorlab;

  /* Do not reclaim the symbols of the rule which action triggered
     this YYERROR.  */
  YYPOPSTACK (yylen);
  yylen = 0;
  YY_STACK_PRINT (yyss, yyssp);
  yystate = *yyssp;
  goto yyerrlab1;


/*-------------------------------------------------------------.
| yyerrlab1 -- common code for both syntax error and YYERROR.  |
`-------------------------------------------------------------*/
yyerrlab1:
  yyerrstatus = 3;	/* Each real token shifted decrements this.  */

  for (;;)
    {
      yyn = yypact[yystate];
      if (!yypact_value_is_default (yyn))
	{
	  yyn += YYTERROR;
	  if (0 <= yyn && yyn <= YYLAST && yycheck[yyn] == YYTERROR)
	    {
	      yyn = yytable[yyn];
	      if (0 < yyn)
		break;
	    }
	}

      /* Pop the current state because it cannot handle the error token.  */
      if (yyssp == yyss)
	YYABORT;


      yydestruct ("Error: popping",
		  yystos[yystate], yyvsp);
      YYPOPSTACK (1);
      yystate = *yyssp;
      YY_STACK_PRINT (yyss, yyssp);
    }

  *++yyvsp = yylval;


  /* Shift the error token.  */
  YY_SYMBOL_PRINT ("Shifting", yystos[yyn], yyvsp, yylsp);

  yystate = yyn;
  goto yynewstate;


/*-------------------------------------.
| yyacceptlab -- YYACCEPT comes here.  |
`-------------------------------------*/
yyacceptlab:
  yyresult = 0;
  goto yyreturn;

/*-----------------------------------.
| yyabortlab -- YYABORT comes here.  |
`-----------------------------------*/
yyabortlab:
  yyresult = 1;
  goto yyreturn;

#if !defined(yyoverflow) || YYERROR_VERBOSE
/*-------------------------------------------------.
| yyexhaustedlab -- memory exhaustion comes here.  |
`-------------------------------------------------*/
yyexhaustedlab:
  yyerror (YY_("memory exhausted"));
  yyresult = 2;
  /* Fall through.  */
#endif

yyreturn:
  if (yychar != YYEMPTY)
    {
      /* Make sure we have latest lookahead translation.  See comments at
         user semantic actions for why this is necessary.  */
      yytoken = YYTRANSLATE (yychar);
      yydestruct ("Cleanup: discarding lookahead",
                  yytoken, &yylval);
    }
  /* Do not reclaim the symbols of the rule which action triggered
     this YYABORT or YYACCEPT.  */
  YYPOPSTACK (yylen);
  YY_STACK_PRINT (yyss, yyssp);
  while (yyssp != yyss)
    {
      yydestruct ("Cleanup: popping",
		  yystos[*yyssp], yyvsp);
      YYPOPSTACK (1);
    }
#ifndef yyoverflow
  if (yyss != yyssa)
    YYSTACK_FREE (yyss);
#endif
#if YYERROR_VERBOSE
  if (yymsg != yymsgbuf)
    YYSTACK_FREE (yymsg);
#endif
  /* Make sure YYID is used.  */
  return YYID (yyresult);
}



